implement Fsmodule;
include "sys.m";
	sys: Sys;
include "draw.m";
include "sh.m";
include "fslib.m";
	fslib: Fslib;
	Report, Value, type2s, quit: import fslib;
	Fschan, Fsdata, Entrychan, Entry,
	Gatechan, Gatequery, Nilentry, Option,
	Next, Down, Skip, Quit: import Fslib;

types(): string
{
	return "xpx";
}

badmod(p: string)
{
	sys->fprint(sys->fildes(2), "fs: size: cannot load %s: %r\n", p);
	raise "fail:bad module";
}

init()
{
	sys = load Sys Sys->PATH;
	fslib = load Fslib Fslib->PATH;
	if(fslib == nil)
		badmod(Fslib->PATH);
}

run(nil: ref Draw->Context, nil: ref Report,
			nil: list of Option, args: list of ref Value): ref Value
{
	dst := chan of (Fsdata, chan of int);
	spawn filterproc((hd tl args).x().i, dst, (hd args).p().i);
	return ref Value.X(dst);
}

filterproc(src, dst: Fschan, query: Gatechan)
{
	names: list of string;
	name: string;
	indent := 0;
	myreply := chan of int;
loop:
	for(;;){
		(d, reply) := <-src;
		if(indent > 0 && d.dir != nil){
			p := name;
			if(p != nil && p[len p - 1] != '/')
				p[len p] = '/';
			query <-= ((d.dir, p + d.dir.name, indent), myreply);
			if(<-myreply == 0){
				reply <-= Next;
				continue;
			}
		}
		dst <-= (d, myreply);
		case reply <-= <-myreply {
		Quit =>
			break loop;
		Next =>
			if(d.dir == nil && d.data == nil){
				if(--indent == 0)
					break loop;
				(name, names) = (hd names, tl names);
			}
		Skip =>
			if(--indent == 0)
				break loop;
			(name, names) = (hd names, tl names);
		Down =>
			if(d.dir != nil){
				names = name :: names;
				if(d.dir.mode & Sys->DMDIR){
					if(indent == 0)
						name = d.dir.name;
					else{
						if(name[len name - 1] != '/')
							name[len name] = '/';
						name += d.dir.name;
					}
				}
				indent++;
			}
		}
	}
	query <-= (Nilentry, nil);
}