implement Limbo;

#line	2	"limbo.y"
include "limbo.m";
include "draw.m";

Limbo: module {

	init:		fn(ctxt: ref Draw->Context, argv: list of string);

	YYSTYPE: adt{
		tok:	Tok;
		ids:	ref Decl;
		node:	ref Node;
		ty:	ref Type;
		types:	ref Typelist;
	};

	YYLEX: adt {
		lval: YYSTYPE;
		lex: fn(nil: self ref YYLEX): int;
		error: fn(nil: self ref YYLEX, err: string);
	};
Landeq: con	57346;
Loreq: con	57347;
Lxoreq: con	57348;
Llsheq: con	57349;
Lrsheq: con	57350;
Laddeq: con	57351;
Lsubeq: con	57352;
Lmuleq: con	57353;
Ldiveq: con	57354;
Lmodeq: con	57355;
Ldeclas: con	57356;
Lload: con	57357;
Loror: con	57358;
Landand: con	57359;
Lcons: con	57360;
Leq: con	57361;
Lneq: con	57362;
Lleq: con	57363;
Lgeq: con	57364;
Llsh: con	57365;
Lrsh: con	57366;
Lexp: con	57367;
Lcomm: con	57368;
Linc: con	57369;
Ldec: con	57370;
Lof: con	57371;
Lref: con	57372;
Lif: con	57373;
Lelse: con	57374;
Lfn: con	57375;
Lexcept: con	57376;
Lraises: con	57377;
Lmdot: con	57378;
Lto: con	57379;
Lor: con	57380;
Lrconst: con	57381;
Lconst: con	57382;
Lid: con	57383;
Ltid: con	57384;
Lsconst: con	57385;
Llabs: con	57386;
Lnil: con	57387;
Llen: con	57388;
Lhd: con	57389;
Ltl: con	57390;
Ltagof: con	57391;
Limplement: con	57392;
Limport: con	57393;
Linclude: con	57394;
Lcon: con	57395;
Ltype: con	57396;
Lmodule: con	57397;
Lcyclic: con	57398;
Ladt: con	57399;
Larray: con	57400;
Llist: con	57401;
Lchan: con	57402;
Lself: con	57403;
Ldo: con	57404;
Lwhile: con	57405;
Lfor: con	57406;
Lbreak: con	57407;
Lalt: con	57408;
Lcase: con	57409;
Lpick: con	57410;
Lcont: con	57411;
Lreturn: con	57412;
Lexit: con	57413;
Lspawn: con	57414;
Lraise: con	57415;
Lfix: con	57416;

};

#line	27	"limbo.y"
	#
	# lex.b
	#
	signdump:	string;			# name of function for sig debugging
	superwarn:	int;
	debug:		array of int;
	noline:		Line;
	nosrc:		Src;
	arrayz:		int;
	emitcode:	string;			# emit stub routines for system module functions
	emitdyn: int;				# emit as above but for dynamic modules
	emitsbl:	string;			# emit symbol file for sysm modules
	emitstub:	int;			# emit type and call frames for system modules
	emittab:	string;			# emit table of runtime functions for this module
	errors:		int;
	mustcompile:	int;
	dontcompile:	int;
	asmsym:		int;			# generate symbols in assembly language?
	bout:		ref Bufio->Iobuf;	# output file
	bsym:		ref Bufio->Iobuf;	# symbol output file; nil => no sym out
	gendis:		int;			# generate dis or asm?
	fixss:		int;
	zeroptrs:		int;

	#
	# decls.b
	#
	scope:		int;
	# impmod:		ref Sym;		# name of implementation module
	impmods:		ref Decl;		# name of implementation module(s)
	nildecl:	ref Decl;		# declaration for limbo's nil
	selfdecl:	ref Decl;		# declaration for self

	#
	# types.b
	#
	tany:		ref Type;
	tbig:		ref Type;
	tbyte:		ref Type;
	terror:		ref Type;
	tint:		ref Type;
	tnone:		ref Type;
	treal:		ref Type;
	tstring:	ref Type;
	texception:	ref Type;
	tunknown:	ref Type;
	rtexception:	ref Type;
	descriptors:	ref Desc;		# list of all possible descriptors
	tattr:		array of Tattr;

	#
	# nodes.b
	#
	opcommute:	array of int;
	oprelinvert:	array of int;
	isused:		array of int;
	casttab:	array of array of int;	# instruction to cast from [1] to [2]

	nfns:		int;			# functions defined
	nfnexp:		int;
	fns:		array of ref Decl;	# decls for fns defined
	tree:		ref Node;		# root of parse tree

	parset:		int;			# time to parse
	checkt:		int;			# time to typecheck
	gent:		int;			# time to generate code
	writet:		int;			# time to write out code
	symt:		int;			# time to write out symbols
YYEOFCODE: con 1;
YYERRCODE: con 2;
YYMAXDEPTH: con 200;

#line	1590	"limbo.y"


include "keyring.m";

sys:	Sys;
	print, fprint, sprint: import sys;

bufio:	Bufio;
	Iobuf: import bufio;

str:		String;

keyring:Keyring;
	md5: import keyring;

math:	Math;
	import_real, export_real, isnan: import math;

yyctxt: ref YYLEX;

canonnan: real;

debug	= array[256] of {* => 0};

noline	= -1;
nosrc	= Src(-1, -1);

infile:	string;

# front end
include "arg.m";
include "lex.b";
include "types.b";
include "nodes.b";
include "decls.b";

include "typecheck.b";

# back end
include "gen.b";
include "ecom.b";
include "asm.b";
include "dis.b";
include "sbl.b";
include "stubs.b";
include "com.b";

init(nil: ref Draw->Context, argv: list of string)
{
	s: string;

	sys = load Sys Sys->PATH;
	keyring = load Keyring Keyring->PATH;
	math = load Math Math->PATH;
	bufio = load Bufio Bufio->PATH;
	if(bufio == nil){
		sys->print("can't load %s: %r\n", Bufio->PATH);
		raise("fail:bad module");
	}
	str = load String String->PATH;
	if(str == nil){
		sys->print("can't load %s: %r\n", String->PATH);
		raise("fail:bad module");
	}

	stderr = sys->fildes(2);
	yyctxt = ref YYLEX;

	math->FPcontrol(0, Math->INVAL|Math->ZDIV|Math->OVFL|Math->UNFL|Math->INEX);
	na := array[1] of {0.};
	import_real(array[8] of {byte 16r7f, * => byte 16rff}, na);
	canonnan = na[0];
	if(!isnan(canonnan))
		fatal("bad canonical NaN");

	lexinit();
	typeinit();
	optabinit();

	gendis = 1;
	asmsym = 0;
	maxerr = 20;
	ofile := "";
	ext := "";
	zeroptrs = 1;

	arg := Arg.init(argv);
	while(c := arg.opt()){
		case c{
		'Y' =>
			emitsbl = arg.arg();
			if(emitsbl == nil)
				usage();
		'C' =>
			dontcompile = 1;
		'D' =>
			#
			# debug flags:
			#
			# a	alt compilation
			# A	array constructor compilation
			# b	boolean and branch compilation
			# c	case compilation
			# d	function declaration
			# D	descriptor generation
			# e	expression compilation
			# E	addressable expression compilation
			# f	print arguments for compiled functions
			# F	constant folding
			# g	print out globals
			# m	module declaration and type checking
			# n	nil references
			# s	print sizes of output file sections
			# S	type signing
			# t	type checking function bodies
			# T	timing
			# v	global var and constant compilation
			# x	adt verification
			# Y	tuple compilation
			# z Z	bug fixes
			#
			s = arg.arg();
			for(i := 0; i < len s; i++){
				c = s[i];
				if(c < len debug)
					debug[c] = 1;
			}
		'I' =>
			s = arg.arg();
			if(s == "")
				usage();
			addinclude(s);
		'G' =>
			asmsym = 1;
		'S' =>
			gendis = 0;
		'a' =>
			emitstub = 1;
		'A' =>
			emitstub = emitdyn = 1;
		'c' =>
			mustcompile = 1;
		'e' =>
			maxerr = 1000;
		'f' =>
			fabort = 1;
		'g' =>
			dosym = 1;
		'i' =>
			doinline = 1;
		'o' =>
			ofile = arg.arg();
		's' =>
			s = arg.arg();
			if(s != nil)
				fixss = int s;
		't' =>
			emittab = arg.arg();
			if(emittab == nil)
				usage();
		'T' =>
			emitcode = arg.arg();
			if(emitcode == nil)
				usage();
		'd' =>
			emitcode = arg.arg();
			if(emitcode == nil)
				usage();
			emitdyn = 1;
		'w' =>
			superwarn = dowarn;
			dowarn = 1;
		'x' =>
			ext = arg.arg();
		'X' =>
			signdump = arg.arg();
		'z' =>
			arrayz = 1;
		'Z' =>
			zeroptrs = 0;
		* =>
			usage();
		}
	}

	addinclude("/module");

	argv = arg.argv;
	arg = nil;

	if(argv == nil){
		usage();
	}else if(ofile != nil){
		if(len argv != 1)
			usage();
		translate(hd argv, ofile, mkfileext(ofile, ".dis", ".sbl"));
	}else{
		pr := len argv != 1;
		if(ext == ""){
			ext = ".s";
			if(gendis)
				ext = ".dis";
		}
		for(; argv != nil; argv = tl argv){
			file := hd argv;
			(nil, s) = str->splitr(file, "/");
			if(pr)
				print("%s:\n", s);
			out := mkfileext(s, ".b", ext);
			translate(file, out, mkfileext(out, ext, ".sbl"));
		}
	}
	if (toterrors > 0)
		raise("fail:errors");
}

usage()
{
	fprint(stderr, "usage: limbo [-GSagwe] [-I incdir] [-o outfile] [-{T|t|d} module] [-D debug] file ...\n");
	raise("fail:usage");
}

mkfileext(file, oldext, ext: string): string
{
	n := len file;
	n2 := len oldext;
	if(n >= n2 && file[n-n2:] == oldext)
		file = file[:n-n2];
	return file + ext;
}

translate(in, out, dbg: string)
{
	infile = in;
	outfile = out;
	errors = 0;
	bins[0] = bufio->open(in, Bufio->OREAD);
	if(bins[0] == nil){
		fprint(stderr, "can't open %s: %r\n", in);
		toterrors++;
		return;
	}
	doemit := emitcode != "" || emitstub || emittab != "" || emitsbl != "";
	if(!doemit){
		bout = bufio->create(out, Bufio->OWRITE, 8r666);
		if(bout == nil){
			fprint(stderr, "can't open %s: %r\n", out);
			toterrors++;
			bins[0].close();
			return;
		}
		if(dosym){
			bsym = bufio->create(dbg, Bufio->OWRITE, 8r666);
			if(bsym == nil)
				fprint(stderr, "can't open %s: %r\n", dbg);
		}
	}

	lexstart(in);

	popscopes();
	typestart();
	declstart();
	nfnexp = 0;

	parset = sys->millisec();
	yyparse(yyctxt);
	parset = sys->millisec() - parset;

	checkt = sys->millisec();
	entry := typecheck(!doemit);
	checkt = sys->millisec() - checkt;

	modcom(entry);

	fns = nil;
	nfns = 0;
	descriptors = nil;

	if(debug['T'])
		print("times: parse=%d type=%d: gen=%d write=%d symbols=%d\n",
			parset, checkt, gent, writet, symt);

	if(bout != nil)
		bout.close();
	if(bsym != nil)
		bsym.close();
	toterrors += errors;
	if(errors && bout != nil)
		sys->remove(out);
	if(errors && bsym != nil)
		sys->remove(dbg);
}

pwd(): string
{
	workdir := load Workdir Workdir->PATH;
	if(workdir == nil)
		cd := "/";
	else
		cd = workdir->init();
	# sys->print("pwd: %s\n", cd);
	return cd;
}

cleanname(s: string): string
{
	ls, path: list of string;

	if(s == nil)
		return nil;
	if(s[0] != '/' && s[0] != '\\')
		(nil, ls) = sys->tokenize(pwd(), "/\\");
	for( ; ls != nil; ls = tl ls)
		path = hd ls :: path;
	(nil, ls) = sys->tokenize(s, "/\\");
	for( ; ls != nil; ls = tl ls){
		n := hd ls;
		if(n == ".")
			;
		else if (n == ".."){
			if(path != nil)
				path = tl path;
		}
		else
			path = n :: path;
	}
	p := "";
	for( ; path != nil; path = tl path)
		p = "/" + hd path + p;
	if(p == nil)
		p = "/";
	# sys->print("cleanname: %s\n", p);
	return p;
}

srcpath(): string
{
	srcp := cleanname(infile);
	# sys->print("srcpath: %s\n", srcp);
	return srcp;
}
yyexca := array[] of {-1, 1,
	1, -1,
	-2, 0,
-1, 3,
	1, 3,
	-2, 0,
-1, 17,
	38, 84,
	49, 60,
	53, 84,
	97, 60,
	-2, 246,
-1, 210,
	58, 29,
	70, 29,
	-2, 0,
-1, 230,
	1, 2,
	-2, 0,
-1, 272,
	49, 171,
	-2, 251,
-1, 305,
	58, 39,
	70, 39,
	90, 39,
	-2, 0,
-1, 307,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 374,
	49, 60,
	97, 60,
	-2, 246,
-1, 375,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 380,
	52, 67,
	53, 67,
	-2, 106,
-1, 382,
	52, 68,
	53, 68,
	-2, 108,
-1, 408,
	58, 39,
	70, 39,
	90, 39,
	-2, 0,
-1, 413,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 420,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 435,
	52, 67,
	53, 67,
	-2, 107,
-1, 436,
	52, 68,
	53, 68,
	-2, 109,
-1, 444,
	70, 272,
	97, 272,
	-2, 158,
-1, 458,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 475,
	49, 121,
	97, 121,
	-2, 233,
-1, 480,
	70, 269,
	-2, 0,
-1, 489,
	58, 45,
	70, 45,
	-2, 0,
-1, 500,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 532,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 538,
	70, 149,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 545,
	55, 57,
	61, 57,
	-2, 60,
-1, 550,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 555,
	70, 152,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 559,
	71, 171,
	-2, 158,
-1, 578,
	70, 155,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 584,
	70, 163,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 588,
	71, 170,
	84, 145,
	85, 145,
	86, 145,
	88, 145,
	89, 145,
	90, 145,
	-2, 0,
-1, 591,
	49, 60,
	55, 166,
	61, 166,
	97, 60,
	-2, 246,
};
YYNPROD: con 277;
YYPRIVATE: con 57344;
yytoknames: array of string;
yystates: array of string;
yydebug: con 0;
YYLAST:	con 2631;
yyact := array[] of {
 373, 573, 358, 445, 307, 491, 311,  49, 443, 377,
 441, 353, 424, 359,  14, 184,  21,  14,  84,  83,
 269, 217,  15, 296, 212,   8, 102, 316,  48,  78,
  79,  80,   4, 363, 110,  12,  23, 357,   6,  42,
 197,   6,   3,  35, 451,  51, 528, 475, 415, 376,
 450, 347, 345, 291,  11, 117, 283, 118, 480, 393,
 163, 164, 165, 166, 167, 168, 169, 170, 171, 172,
 173, 174, 175, 185,  43, 112, 181, 182, 183, 326,
 284, 226,  71,  10, 223,  46,  10,  93,  37,  22,
 503,  22, 581, 567, 114, 531, 414, 204,  40, 207,
 344, 494,  44, 402, 284, 284, 344, 119, 344, 292,
 474, 292, 225, 472, 284, 119, 471,  31, 470, 219,
 430, 407, 416, 407, 231, 232, 233, 234, 235, 236,
 237, 238, 239, 240, 241,  14, 243, 244, 245, 246,
 247, 248, 249, 250, 251, 252, 253, 254, 255, 256,
 257, 258, 259, 260, 261, 262, 263, 264, 185,   6,
  32, 272, 186, 401, 230,  32, 420, 419, 418,  50,
 422, 421, 423, 266, 228, 499, 399, 277,  94, 206,
  47, 282, 309, 308,  52,  53,  56,  22, 286, 201,
  59,  72, 209, 287, 270,  57,  58,  26,  63, 348,
 211,  73, 229, 216,  10, 268,  25, 300,  24,  76,
  75,  69,  68,  74, 583,  18,  54,  55,  62,  60,
  61,  64, 577, 193, 194, 208, 554, 193, 194, 537,
   5,  87, 521,  65,  66,  67, 513, 479,  85, 392,
 214,  90, 498, 322,  14, 295, 205, 548, 468,  77,
 302,  92,  82, 319, 456, 310, 192, 408, 314, 112,
 412, 411, 410,  23, 391,  70,  19, 280,   6, 306,
  43, 476, 210,  88,  89,  86, 193, 194, 114,  19,
 320, 185, 181,  33, 321, 335,  17, 331,   5,  77,
  18, 562, 193, 194, 561, 541, 333,  91,  44,  45,
  91, 576,  13,  18, 193, 194, 586, 213, 524, 433,
 336, 518, 596,  10, 375, 193, 194, 350, 312, 305,
 219, 434, 343, 191,  19, 378, 352, 386, 355, 351,
 193, 194, 575, 279, 512, 482, 382, 380, 395, 586,
 482, 594, 490, 525,  17, 585, 582, 385,  18, 484,
 547,  91, 493,  91, 545, 193, 194, 574,   2, 384,
  13,  91, 482, 404, 396, 397, 413, 406, 579,  87,
 428, 482,  91, 185, 298, 527,  85, 570, 482,  90,
 426,  99, 182, 469, 556, 482, 425, 482, 431,  92,
  82, 539, 444, 483, 335, 331,  22, 289, 493, 288,
 436, 435, 427, 313, 429, 267, 454, 453,  19, 156,
 101,  88,  89,  86, 120, 104,  39, 458, 462, 108,
 457, 158, 467, 465,  19, 193, 194,  77, 115, 433,
 103,  36, 116, 496, 466, 157,  87, 160, 297, 161,
 162, 444, 504,  85, 115,  91,  90, 550, 116, 159,
 158, 478, 455, 409, 167, 486,  92,  82, 400, 325,
 224, 185,  91, 106,  34,  91,  91, 404,  91, 509,
  81, 406, 508,  97, 394,  91, 497, 390,  88,  89,
  86, 444, 515, 509, 517, 330, 516, 328, 520, 514,
  91,  91, 200, 199,  77, 176, 522, 501, 502, 327,
 529, 180, 196, 530, 176, 179, 509, 178, 177, 536,
 438, 540, 538, 437, 466, 143, 142, 140, 141, 137,
 138, 139, 136, 134, 195, 324, 198, 341, 543, 546,
 227, 340,  41, 202, 203, 552, 544, 588, 568, 559,
 555, 532, 557, 379, 323, 220, 466, 222, 221, 509,
 533, 464, 565, 566, 463, 460, 559, 417,  91, 569,
 136, 134, 105,  39, 466, 551, 215, 553, 187, 578,
 140, 141, 137, 138, 139, 136, 134, 584,  19, 559,
 510,  29, 587,  91,  27, 242, 589, 523, 593, 354,
 304, 595,  30,  91,  91,  28, 285, 362, 121, 182,
 167, 580, 466,   1, 271, 273,  91,  91,  63, 218,
  91,  73, 137, 138, 139, 136, 134, 526, 281,  76,
  75,  69,  68,  74, 564,  18,  54,  55,  62,  60,
  61,  64, 563, 405, 489, 290, 488, 572, 293, 294,
 571,  16, 403,  65,  66,  67, 303,  91, 198, 349,
   9, 535, 534, 507, 506,   7,  91, 442,  87,  77,
  91, 332,  87, 315, 318,  85,  91,  72,  90,  85,
  99, 265,  90, 492, 365,  91, 109,  73,  92,  82,
 107,  91,  92,  82, 113,  76,  75,  45, 111,  74,
  20,  18,  38,  96,   0,  98,  95, 360,   0,  91,
  88,  89,  86,   0,  88,  89,  86, 317,   0,   0,
   0,  50,   0,   0,   0,   0,  77,   0,   0,  91,
  77,  91,   0,   0,   0,   0,  52,  53,  56,   0,
   0, 342,  59, 372,   0,   0,   0,  57,  58,   0,
  63, 364,  91,  73,   0,   0,   0,   0,   0,   0,
   0,  76,  75, 374,  68,  74, 383,  18,  54,  55,
  62,  60,  61,  64, 361, 495, 388, 389,   0,  13,
   0,   0,   0,   0,   0,  65,  66,  67,   0,   0,
   0,   0, 366, 398,   0,   0, 367, 368, 371, 369,
 370,  77,   0,  87,   0,   0,   0,   0,   0,   0,
  85,   0,   0,  90,   0,  99,   0,   0,   0,   0,
   0,   0,   0,  92,  82,   0,   0,   0,   0,   0,
 195,   0,   0,   0,   0,   0,   0,   0,  96, 439,
  98,  95, 100, 448, 101,  88,  89,  86,   0, 452,
   0,   0,   0,   0, 360,   0,   0,   0,  97,   0,
   0,  77,   0,   0, 461,   0,   0,   0,  50, 144,
 145, 146, 147, 143, 142, 140, 141, 137, 138, 139,
 136, 134, 477,  52,  53,  56,   0,   0,   0,  59,
 372,   0,   0,   0,  57,  58,   0,  63, 364,   0,
  73,   0, 485,   0, 477,   0,   0,   0,  76,  75,
 374,  68,  74,   0,  18,  54,  55,  62,  60,  61,
  64, 361, 459, 360,   0, 511,  13,   0,   0,   0,
   0,   0,  65,  66,  67,   0,   0,  50,   0, 366,
   0,   0,   0, 367, 368, 371, 369, 370,  77,   0,
   0,   0,  52,  53,  56,   0,   0,   0,  59, 372,
   0,   0,   0,  57,  58,   0,  63, 364,   0,  73,
   0,   0,   0,   0,   0,   0,   0,  76,  75, 374,
  68,  74,   0,  18,  54,  55,  62,  60,  61,  64,
 361, 432, 360,   0,   0,  13,   0,   0,   0,   0,
   0,  65,  66,  67,   0,   0,  50,   0, 366,   0,
   0,   0, 367, 368, 371, 369, 370,  77,   0,   0,
   0,  52,  53,  56,   0,   0,   0,  59, 372,   0,
   0,   0,  57,  58,   0,  63, 364,   0,  73,   0,
   0,   0,   0,   0,   0,   0,  76,  75, 374,  68,
  74,   0,  18,  54,  55,  62,  60,  61,  64, 361,
 356, 590,   0,   0,  13,   0,   0,   0,   0,   0,
  65,  66,  67,   0,   0,  50,   0, 366,   0,   0,
   0, 367, 368, 371, 369, 370,  77,   0,   0,   0,
  52,  53, 592,   0,   0,   0,  59, 372,   0,   0,
   0,  57,  58,   0,  63, 364,   0,  73,   0,   0,
   0,   0,   0,   0,   0,  76,  75, 591,  68,  74,
   0,  18,  54,  55,  62,  60,  61,  64, 361, 558,
   0,   0,   0,  13,   0,   0,   0,   0,   0,  65,
  66,  67,   0,  50,   0,   0, 366,   0,   0,   0,
 367, 368, 371, 369, 370,  77,   0,   0,  52,  53,
 446,   0,   0,   0,  59, 372,   0,   0,   0,  57,
  58,   0,  63, 364,   0,  73,   0,   0,   0,   0,
   0,   0,   0,  76,  75, 374,  68,  74,   0,  18,
  54,  55,  62,  60,  61,  64, 361,   0,   0,   0,
   0,  13,   0,   0,   0,   0,   0,  65,  66,  67,
   0,   0,   0,   0, 366,   0,   0,   0, 367, 368,
 371, 369, 370,  77, 123, 124, 125, 126, 127, 128,
 129, 130, 131, 132, 133, 135,   0, 155, 154, 153,
 152, 151, 150, 148, 149, 144, 145, 146, 147, 143,
 142, 140, 141, 137, 138, 139, 136, 134, 360, 338,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  50,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,  52,  53,  56,
   0,   0,   0,  59, 372,   0,   0,   0,  57,  58,
   0,  63, 364,   0,  73,   0,   0,   0,   0,   0,
   0,   0,  76,  75, 374,  68,  74, 337,  18,  54,
  55,  62,  60,  61,  64, 361, 447,   0,   0,   0,
   0,   0,   0,   0,   0,   0,  65,  66,  67,   0,
  50,   0,   0, 366,   0,   0,   0, 367, 368, 371,
 369, 370,  77,   0,   0,  52,  53, 446,  87,   0,
   0,  59,  72,   0,   0,  85,  57,  58,  90,  63,
   0,   0,  73,   0,   0,   0,   0,   0,  92,  82,
  76,  75,  69,  68,  74,   0,  18,  54,  55,  62,
  60,  61,  64,   0,   0, 487,  50,   0, 476,   0,
  88,  89,  86,   0,  65,  66,  67,   0,   0,   0,
   0,  52,  53,  56,   0,   0,  77,  59,  72,   0,
  77, 278,  57,  58,   0,  63,   0,   0,  73,   0,
   0,   0,   0,   0,   0,   0,  76,  75,  69,  68,
  74,   0,  18,  54,  55,  62,  60,  61,  64,   0,
   0,  50,   0,   0,   0,   0,   0,   0,   0,   0,
  65,  66,  67,   0,   0,   0,  52,  53,  56,   0,
   0,   0,  59,  72,   0,   0,  77,  57,  58,   0,
  63,   0,   0,  73,   0,   0,   0,   0,   0,   0,
   0,  76,  75,  69, 274,  74,   0,  18,  54,  55,
  62,  60,  61,  64,   0,   0,   0,  52,  53,  56,
   0,   0,   0,  59,  72, 275, 276,  67,  57,  58,
   0,  63,   0,   0,  73,   0,   0,   0,   0,   0,
   0,  77,  76,  75,  69,  68,  74,   0,  18,  54,
  55,  62,  60,  61,  64,  87,   0,   0,   0,   0,
   0,   0,  85,  87,   0,  90,  65,  66,  67,   0,
  85,   0,   0,  90,   0,  92,  82,   0,   0,   0,
   0,   0,  77,  92,  82,   0, 440,   0,   0,   0,
   0,   0,   0,   0, 280,   0,   0,  88,  89,  86,
   0,   0,   0,   0,   0,  88,  89,  86,   0,   0,
   0,   0,   0,  77,   0,   0,   0,   0,   0,   0,
   0,  77, 123, 124, 125, 126, 127, 128, 129, 130,
 131, 132, 133, 135,   0, 155, 154, 153, 152, 151,
 150, 148, 149, 144, 145, 146, 147, 143, 142, 140,
 141, 137, 138, 139, 136, 134, 155, 154, 153, 152,
 151, 150, 148, 149, 144, 145, 146, 147, 143, 142,
 140, 141, 137, 138, 139, 136, 134, 123, 124, 125,
 126, 127, 128, 129, 130, 131, 132, 133, 135, 549,
 155, 154, 153, 152, 151, 150, 148, 149, 144, 145,
 146, 147, 143, 142, 140, 141, 137, 138, 139, 136,
 134, 154, 153, 152, 151, 150, 148, 149, 144, 145,
 146, 147, 143, 142, 140, 141, 137, 138, 139, 136,
 134,   0, 123, 124, 125, 126, 127, 128, 129, 130,
 131, 132, 133, 135, 542, 155, 154, 153, 152, 151,
 150, 148, 149, 144, 145, 146, 147, 143, 142, 140,
 141, 137, 138, 139, 136, 134, 153, 152, 151, 150,
 148, 149, 144, 145, 146, 147, 143, 142, 140, 141,
 137, 138, 139, 136, 134,   0,   0, 123, 124, 125,
 126, 127, 128, 129, 130, 131, 132, 133, 135, 519,
 155, 154, 153, 152, 151, 150, 148, 149, 144, 145,
 146, 147, 143, 142, 140, 141, 137, 138, 139, 136,
 134,   0,  87,   0,   0,   0,  87,   0,   0,  85,
   0,   0,  90, 381,   0,   0,  90,   0,   0,   0,
   0,   0,  92, 387,   0,   0,  92,  82,   0,   0,
   0,   0,   0,   0, 473,   0,   0,   0,   0,   0,
   0,   0,   0,   0,  88,  89,  86,   0,  88,  89,
  86,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  77,   0,   0,   0,  77, 123, 124, 125, 126, 127,
 128, 129, 130, 131, 132, 133, 135,   0, 155, 154,
 153, 152, 151, 150, 148, 149, 144, 145, 146, 147,
 143, 142, 140, 141, 137, 138, 139, 136, 134, 151,
 150, 148, 149, 144, 145, 146, 147, 143, 142, 140,
 141, 137, 138, 139, 136, 134,   0,   0,   0,   0,
 123, 124, 125, 126, 127, 128, 129, 130, 131, 132,
 133, 135, 346, 155, 154, 153, 152, 151, 150, 148,
 149, 144, 145, 146, 147, 143, 142, 140, 141, 137,
 138, 139, 136, 134, 150, 148, 149, 144, 145, 146,
 147, 143, 142, 140, 141, 137, 138, 139, 136, 134,
   0,   0,   0,   0,   0, 123, 124, 125, 126, 127,
 128, 129, 130, 131, 132, 133, 135, 339, 155, 154,
 153, 152, 151, 150, 148, 149, 144, 145, 146, 147,
 143, 142, 140, 141, 137, 138, 139, 136, 134, 148,
 149, 144, 145, 146, 147, 143, 142, 140, 141, 137,
 138, 139, 136, 134,   0,   0,   0,   0,   0,   0,
 123, 124, 125, 126, 127, 128, 129, 130, 131, 132,
 133, 135, 301, 155, 154, 153, 152, 151, 150, 148,
 149, 144, 145, 146, 147, 143, 142, 140, 141, 137,
 138, 139, 136, 134,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0, 123, 124, 125, 126, 127,
 128, 129, 130, 131, 132, 133, 135, 299, 155, 154,
 153, 152, 151, 150, 148, 149, 144, 145, 146, 147,
 143, 142, 140, 141, 137, 138, 139, 136, 134,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
 123, 124, 125, 126, 127, 128, 129, 130, 131, 132,
 133, 135, 190, 155, 154, 153, 152, 151, 150, 148,
 149, 144, 145, 146, 147, 143, 142, 140, 141, 137,
 138, 139, 136, 134,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0, 123, 124, 125, 126, 127,
 128, 129, 130, 131, 132, 133, 135, 189, 155, 154,
 153, 152, 151, 150, 148, 149, 144, 145, 146, 147,
 143, 142, 140, 141, 137, 138, 139, 136, 134,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
 123, 124, 125, 126, 127, 128, 129, 130, 131, 132,
 133, 135, 188, 155, 154, 153, 152, 151, 150, 148,
 149, 144, 145, 146, 147, 143, 142, 140, 141, 137,
 138, 139, 136, 134,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0, 123, 124, 125, 126, 127,
 128, 129, 130, 131, 132, 133, 135, 122, 155, 154,
 153, 152, 151, 150, 148, 149, 144, 145, 146, 147,
 143, 142, 140, 141, 137, 138, 139, 136, 134,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0, 123, 124,
 125, 126, 127, 128, 129, 130, 131, 132, 133, 135,
 560, 155, 154, 153, 152, 151, 150, 148, 149, 144,
 145, 146, 147, 143, 142, 140, 141, 137, 138, 139,
 136, 134,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0, 123, 124, 125, 126, 127, 128, 129, 130, 131,
 132, 133, 135, 505, 155, 154, 153, 152, 151, 150,
 148, 149, 144, 145, 146, 147, 143, 142, 140, 141,
 137, 138, 139, 136, 134,   0,   0,   0,   0, 123,
 124, 125, 126, 127, 128, 129, 130, 131, 132, 133,
 135, 481, 155, 154, 153, 152, 151, 150, 148, 149,
 144, 145, 146, 147, 143, 142, 140, 141, 137, 138,
 139, 136, 134,   0,   0,   0, 334, 123, 124, 125,
 126, 127, 128, 129, 130, 131, 132, 133, 135,   0,
 155, 154, 153, 152, 151, 150, 148, 149, 144, 145,
 146, 147, 143, 142, 140, 141, 137, 138, 139, 136,
 134,   0,   0,   0, 329, 123, 124, 125, 126, 127,
 128, 129, 130, 131, 132, 133, 135,   0, 155, 154,
 153, 152, 151, 150, 148, 149, 144, 145, 146, 147,
 143, 142, 140, 141, 137, 138, 139, 136, 134,   0,
 500, 123, 124, 125, 126, 127, 128, 129, 130, 131,
 132, 133, 135,   0, 155, 154, 153, 152, 151, 150,
 148, 149, 144, 145, 146, 147, 143, 142, 140, 141,
 137, 138, 139, 136, 134,   0, 449, 123, 124, 125,
 126, 127, 128, 129, 130, 131, 132, 133, 135,   0,
 155, 154, 153, 152, 151, 150, 148, 149, 144, 145,
 146, 147, 143, 142, 140, 141, 137, 138, 139, 136,
 134,
};
yypact := array[] of {
 286,-1000, 338, 228,-1000, 137,-1000,-1000, 135, 126,
 580, 577,  68, 223, 415,-1000, 378, 492,-1000, 241,
 -12, 109,-1000,-1000,-1000,-1000,-1000, 153, 153, 153,
 153, 398, 540, 107, 755, 379, 357, 543, 414, 386,
-1000, 338,  18,-1000,-1000,-1000, 356,-1000,2246,-1000,
 351, 397,1466,1466,1466,1466,1466,1466,1466,1466,
1466,1466,1466,1466,1466, 464, 463, 461,1466, 563,
1466,-1000, 153, 525,-1000,-1000,-1000, 530,2191,2136,
2081, 252,-1000,-1000,-1000, 398, 458, 398, 449, 448,
 492,-1000, 493,-1000,-1000, 398, 153, 175, 153, 154,
 203, 492, 238, 528, 492, 338, 398, 509, 508, -13,
-1000, 411,  63, -16,-1000,-1000,-1000, 489,-1000, 241,
-1000, 228,-1000, 153, 153, 153, 153, 153, 153, 153,
 153, 153, 153, 153, 581, 153, 153, 153, 153, 153,
 153, 153, 153, 153, 153, 153, 153, 153, 153, 153,
 153, 153, 153, 153, 153, 153, 153, 153, 347, 629,
1425,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,1370, 274, 198, 398,
 153,-1000,-1000,-1000,  17,2593,-1000, 153,-1000,-1000,
-1000,-1000, 153, 341, 339, 373, 398,  14, 373, 398,
 398, 525, 398, 303,2026,-1000, 153,1971,-1000, 398,
 588, 250,-1000,-1000, 113, 241,-1000,-1000,-1000, 257,
 373,-1000,-1000, 370, 624, 624, 222,-1000,-1000,-1000,
 228,2593,2593,2593,2593,2593,2593,2593,2593,2593,
2593,2593, 153,2593, 524, 524, 524, 524, 579, 579,
 539, 539, 486, 486, 486, 486, 834, 834,1986,1932,
1878,1727,1727,1673,1619, 505, -17,-1000, 368, 484,
 410, -18,2593,-1000,1466, 455, 443,2483, 441,1466,
 153, 373,2445,-1000, 153, 238,1210,1916, 491, 487,
 373,-1000, 398, 373, 373, 379,  11, 373,-1000,-1000,
1861,-1000,  12, 129,-1000, 587, 338, 980,-1000,-1000,
  10, 338,-1000, 504,-1000, 373,-1000,1768, 373,-1000,
-1000,-1000,2593,-1000,-1000, 153,1425,1764,1505, 433,
 195,-1000, 169, -38, 430,2593,-1000, 153,-1000,-1000,
 398, 398, 373,-1000, 398,-1000,-1000, 105,-1000,-1000,
 409,  92,-1000,  33,-1000, 188,-1000,-1000,-1000, 404,
 191,-1000,  -1,  51, 519,  82, 328, 328, 153, 153,
 153,  49, 153,2593, 563, 911,-1000,-1000, 260,-1000,
-1000, 398,-1000, 373, 472, 469,2593,1466, 373, 373,
1497,1314,-1000, 153, 398,2557,   9,   3, 373,-1000,
 331,-1000,-1000,-1000,-1000,-1000, 403, 185, 587, 620,
-1000,-1000,-1000, 842, 517, 398,-1000, 153, 516, 513,
1246, 153, 179, 325,  47,-1000,  45,  42,1763,  39,
-1000,   8,-1000, 193,-1000,-1000,-1000,-1000,-1000, 373,
1314, 167, -39,-1000,2407, 332,1466,-1000, 373,-1000,
-1000,-1000, 278, 398, 153,1310, 340,  31, 695, 383,
 153, 171,2521, 153, 153,   5, 393,2354,1314, 565,
-1000,-1000,-1000,-1000,-1000,-1000, 398, 263, 166,-1000,
1314, 153,1314, 153,-1000, 240,1708, 153, 162, 585,
-1000, 247, 288,-1000,-1000,-1000, 317,   7,-1000, 153,
1246,  24, 502, 512,-1000,1314, 159,-1000, 330,2407,
 153, 224,-1000,-1000,-1000,2593,-1000,2593,-1000,-1000,
1653,-1000, 296, 294,-1000, 292, 178,-1000,-1000,1598,
 400, 153,1246, 153, 156,-1000, 323,-1000,1117,-1000,
2301,-1000,-1000, 233, 380,-1000, 230,-1000,1314,-1000,
1246,  22,-1000, 499,-1000,1117,-1000, 316, 191,2407,
 299,-1000,-1000, 152,-1000, 307,-1000, 153,  21, 285,
-1000, 144,-1000, 284,-1000,-1000,-1000,-1000,1117,-1000,
 498,-1000,-1000,-1000,1049,-1000, 299, 280,1246, 251,
 191, 563,1466,-1000,-1000,-1000,-1000,
};
yypgo := array[] of {
   0, 438, 692,  88,  43,  27, 265,  19,  18,  13,
 690, 688, 684,  40, 680, 676,  34, 674,  12,   5,
 673,  98,  33,   0,   7,  45,  15, 671, 661,  82,
  35,  54,  39,  10, 657,   8,   3,  37,  42,  32,
 655,  24,   2,   4, 654, 653, 652, 651, 650,  25,
 649, 646, 642,  11, 641, 640, 637,   1, 636, 634,
 633,   9,   6, 632, 624, 617,  22,  26, 609,  21,
 605,  20, 604,  23, 603, 598, 597, 596,
};
yyr1 := array[] of {
   0,  75,  74,  74,  38,  38,  39,  39,  39,  39,
  39,  39,  39,  39,  39,  39,  39,  30,  30,  37,
  37,  37,  37,  37,  37,  37,  66,  66,  48,  51,
  51,  51,  50,  50,  50,  50,  50,  49,  49,  53,
  53,  53,  52,  52,  52,  62,  62,  61,  61,  60,
  58,  58,  58,  59,  59,  59,  19,  20,  20,   9,
  10,  10,   6,   6,  73,  73,   1,   1,   1,   1,
   1,   1,   1,   1,   1,   1,   1,   1,   7,   7,
   8,   8,  13,  13,  21,  21,   2,   2,   2,   3,
   3,   4,   4,  14,  14,  15,  15,  16,  16,  16,
  16,  11,  12,  12,  12,  12,   5,   5,   5,   5,
  40,  67,  67,  41,  41,  41,  54,  54,  43,  43,
  43,  76,  76,  42,  42,  42,  42,  42,  42,  42,
  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,
  42,  42,  42,  42,  42,  17,  17,  18,  18,  44,
  45,  45,  46,  47,  47,  63,  64,  64,  36,  36,
  36,  36,  36,  55,  56,  56,  57,  57,  57,  57,
  22,  22,  23,  23,  23,  23,  23,  23,  23,  23,
  23,  23,  23,  23,  23,  23,  23,  23,  23,  23,
  23,  23,  23,  23,  23,  23,  23,  23,  23,  23,
  23,  23,  23,  23,  23,  23,  23,  24,  24,  24,
  24,  24,  24,  24,  24,  24,  24,  24,  24,  24,
  24,  24,  24,  24,  24,  24,  24,  24,  24,  24,
  24,  25,  25,  25,  77,  25,  25,  25,  25,  25,
  25,  25,  25,  25,  25,  25,  29,  29,  31,  72,
  72,  71,  71,  70,  70,  70,  65,  65,  32,  32,
  32,  32,  27,  27,  28,  28,  26,  26,  33,  33,
  34,  34,  35,  35,  69,  68,  68,
};
yyr2 := array[] of {
   0,   0,   5,   1,   1,   2,   2,   1,   1,   2,
   2,   4,   4,   4,   4,   4,   6,   1,   3,   3,
   5,   5,   4,   6,   5,   1,   4,   7,   6,   0,
   2,   1,   4,   2,   5,   5,   1,   7,   9,   0,
   2,   1,   1,   1,   5,   0,   2,   5,   4,   4,
   2,   2,   1,   2,   4,   4,   1,   1,   3,   1,
   1,   3,   6,   4,   1,   3,   1,   1,   1,   3,
   6,   2,   3,   3,   3,   3,   4,   1,   1,   4,
   3,   6,   1,   3,   0,   3,   3,   3,   5,   1,
   3,   1,   3,   0,   1,   1,   3,   3,   3,   3,
   3,   1,   1,   1,   3,   3,   2,   3,   2,   3,
   4,   4,   0,   3,   2,   4,   2,   4,   0,   2,
   2,   3,   5,   2,   2,   4,   3,   4,   6,   2,
   5,   7,  10,   6,   8,   3,   3,   3,   3,   3,
   6,   5,   8,   2,   8,   0,   2,   0,   1,   2,
   2,   4,   2,   2,   4,   2,   2,   4,   1,   3,
   1,   3,   1,   2,   2,   4,   1,   1,   3,   1,
   0,   1,   1,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   4,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   1,   2,   2,
   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
   2,   6,   8,   7,   5,   3,   6,   4,   2,   2,
   2,   1,   4,   3,   0,   4,   3,   3,   4,   6,
   2,   2,   1,   1,   1,   6,   1,   1,   3,   1,
   3,   1,   1,   1,   3,   3,   1,   0,   1,   1,
   3,   3,   0,   1,   1,   2,   1,   3,   1,   2,
   1,   3,   1,   3,   2,   2,   4,
};
yychk := array[] of {
-1000, -74,  72, -38, -39,   2, -37, -40, -49, -48,
 -29, -31, -30,  74,  -9, -66, -54,  58,  62,  38,
 -10,  -9,  58, -39,  71,  71,  71,   4,  15,   4,
  15,  49,  97,  60,  49,  -4,  53,  -3,  -2,  38,
 -21,  40, -32, -31, -29,  58,  97,  71, -23, -24,
  16, -25,  31,  32,  63,  64,  33,  42,  43,  37,
  66,  67,  65,  45,  68,  80,  81,  82,  59,  58,
  -6, -29,  38,  48,  60,  57,  56,  96, -23, -23,
 -23,  -1,  59,  -7,  -8,  45,  82,  38,  80,  81,
  48,  -6,  58, -31,  71,  76,  73,  -1,  75,  50,
  77,  79, -67,  51,  58,  19,  49, -14,  33, -15,
 -16, -11, -30, -12, -31,  58,  62,  -9,  39,  97,
  58, -75,  71,   4,   5,   6,   7,   8,   9,  10,
  11,  12,  13,  14,  37,  15,  36,  33,  34,  35,
  31,  32,  30,  29,  25,  26,  27,  28,  23,  24,
  22,  21,  20,  19,  18,  17,  58,  38,  53,  52,
  40,  42,  43, -24, -24, -24, -24, -24, -24, -24,
 -24, -24, -24, -24, -24, -24,  40,  44,  44,  44,
  40, -24, -24, -24, -26, -23,  -3,  38,  71,  71,
  71,  71,   4,  52,  53,  -1,  44, -13,  -1,  44,
  44, -21,  40,  -1, -23,  71,   4, -23,  71,  38,
  69, -21, -41,  69,   2,  38, -21, -69, -68,  -9,
  -1,  39,  39,  97,  49,  49,  97,  41, -31, -29,
 -38, -23, -23, -23, -23, -23, -23, -23, -23, -23,
 -23, -23,   4, -23, -23, -23, -23, -23, -23, -23,
 -23, -23, -23, -23, -23, -23, -23, -23, -23, -23,
 -23, -23, -23, -23, -23, -27, -26,  58, -25, -71,
 -22, -72, -23, -70,  59,  80,  81, -23,  41,  59,
  69,  -1, -23,  39,  97, -77, -23, -23,  58,  58,
  -1,  39,  97,  -1,  -1,  -4, -73,  -1,  71,  71,
 -23,  71, -13, -51,   2,  69,  19, -43,  70,  69,
 -32, -62,  61,  33, -16,  -1,  -5,  83,  -1,  -5,
  58,  62, -23,  39,  41,  49,  97,  44,  44,  41,
  44, -24, -28, -26,  41, -23, -41,  97,  39,  71,
  40,  40,  -1, -67,  97,  41,  71,  39,  70, -50,
  -9, -49, -66, -53,   2, -69,  70, -37, -42,  -9,
   2,  69, -76, -22,  46, -17,  87,  91,  92,  94,
  95,  93,  38, -23,  58, -43,  39, -61,  -9,  39,
  -7,  45,  -8,  -1, -22, -71, -23,  59,  -1,  -1,
  44,  69,  70,  97,  44, -23, -73, -73,  -1,  71,
  49,  71,  70, -52, -61, -60,  -9,  90,  69,  49,
  71,  70,  69, -43,  97,  49,  71,  38,  86,  85,
  84,  89,  88,  90, -18,  58, -18, -22, -23, -22,
  71, -26,  70,  49,  61,  -7,  -8,  41,  41,  -1,
  69, -33, -34, -35, -23, -36,  33,   2,  -1,  39,
  41,  41,  -1,  76,  75,  49,  69, -53, -43,  70,
  38,  -1, -23,  38,  38, -42,  -9, -23,  69,  58,
  71,  71,  71,  71,  71,  39,  78,  -1, -33,  70,
  97,  54,  55,  61,  71,  -1, -23,  75, -58, -59,
   2, -19, -20,  58,  70,  70,  50, -26,  71,   4,
  39, -22, -22,  85,  49,  69, -44, -45, -36, -23,
  15,  -1,  71,  70, -35, -23, -36, -23,  71,  71,
 -23,  70, -62,   2,  61,  55, -65,  58,  39, -23,
 -42,  71,  39,  38, -46, -47, -36,  70, -43,  61,
 -23,  71,  71, -19,  -9,  58, -19,  58,  69,  71,
  47, -22, -42, -22,  70, -43,  61, -36,   2, -23,
  69,  61,  61, -63, -64, -36, -42,  71,  39, -36,
  61, -55, -56, -57,  58,  33,   2,  70, -43,  61,
 -22,  71,  61,  70, -43,  61,  55, -36,  39, -57,
   2,  58,  33, -57,  61, -42,  61,
};
yydef := array[] of {
   0,  -2,   0,  -2,   4,   0,   7,   8,   0,   0,
   0,  17,   0,   0,   0,  25,   0,  -2, 247,   0,
  59,   0,  60,   5,   6,   9,  10,   0,   0,   0,
   0,   0,   0,   0,   0, 112,   0,  91,  89,  93,
 116,   0,   0, 258, 259, 246,   0,   1,   0, 172,
   0, 207,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0, 246,
   0, 231,   0,   0, 242, 243, 244,   0,   0,   0,
   0,   0,  66,  67,  68,   0,   0,   0,   0,   0,
  84,  77,  78,  18,  19,   0,   0,   0,   0,   0,
   0,  84,   0,   0,  84,   0,   0,   0,   0,  94,
  95,   0,   0, 101,  17, 102, 103,   0, 248,   0,
  61,   0,  11,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0, 262,   0,   0,
 170, 240, 241, 208, 209, 210, 211, 212, 213, 214,
 215, 216, 217, 218, 219, 220,   0,   0,   0,   0,
   0, 228, 229, 230,   0, 266, 234,   0,  13,  12,
  14,  15,   0,   0,   0,  71,   0,   0,  82,   0,
   0,   0,   0,   0,   0,  22,   0,   0,  26,   0,
  -2,   0, 110, 118,   0,   0, 117,  92,  45,   0,
  90,  86,  87,   0,   0,   0,   0,  85, 260, 261,
  -2, 173, 174, 175, 176, 177, 178, 179, 180, 181,
 182, 183,   0, 185, 187, 188, 189, 190, 191, 192,
 193, 194, 195, 196, 197, 198, 199, 200, 201, 202,
 203, 204, 205, 206, 186,   0, 263, 236, 237, 249,
   0,   0,  -2, 252, 253,   0,   0,   0,   0,   0,
   0, 225,   0, 233,   0,   0,   0,   0,  69,  80,
  72,  73,   0,  74,  75, 112,   0,  64,  20,  21,
   0,  24,   0,   0,  31,  -2,   0,  -2, 114, 118,
   0, 274, 275,   0,  96,  97,  98,   0,  99, 100,
 104, 105, 184, 232, 238, 170,   0,   0,   0,   0,
   0, 227,   0, 264,   0, 267, 235,   0,  63,  16,
   0,   0,  83,  76,   0,  79,  23,   0,  28,  30,
   0,   0,  36,   0,  41,   0, 113, 119, 120,   0,
   0, 118,   0,   0,   0,   0, 147, 147, 170,   0,
 170,   0,   0, 171,  -2,  -2, 111,  46,   0,  88,
  -2,   0,  -2,   0,   0, 250, 251,  66, 254, 255,
   0,   0, 224, 265,   0,   0,   0,   0,  65,  27,
   0,  33,  37,  40,  42,  43,   0,   0,  -2, 146,
 123, 124, 118,  -2,   0,   0, 129,   0,   0,   0,
  -2,   0,   0,   0,   0, 148,   0,   0,   0,   0,
 143,   0, 115,   0, 276,  -2,  -2, 239, 245, 221,
   0,   0, 268, 270,  -2,   0, 160, 162, 226,  62,
  70,  81,   0,   0,   0,   0,   0,   0,  -2, 126,
   0,   0,   0, 170, 170,   0,   0,   0,   0,   0,
 135, 136, 137, 138, 139,  -2,   0,   0,   0, 223,
  -2,   0,   0,   0,  32,   0,   0,   0,   0,  -2,
  52,   0,  56,  57,  38, 125, 257,   0, 127,   0,
  -2,   0,   0,   0, 146,   0,   0, 118,   0, 158,
   0,   0,  48, 222, 271, 159, 161, 273,  34,  35,
   0,  49,  50,  51,  53,   0,   0, 256, 122,   0,
 130, 170,  -2, 170,   0, 118,   0, 141,  -2, 150,
   0,  47,  44,   0,   0,  -2,   0,  58,   0, 128,
  -2,   0, 133,   0, 140,  -2, 153,   0, 162,  -2,
   0,  54,  55,   0, 118,   0, 131, 170,   0,   0,
 151,   0, 118,   0, 166, 167, 169, 144,  -2, 156,
   0, 134, 154, 142,  -2, 164,   0,   0,  -2,   0,
 169,  -2, 167, 168, 157, 132, 165,
};
yytok1 := array[] of {
   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,  63,   3,   3,   3,  35,  22,   3,
  38,  39,  33,  31,  97,  32,  53,  34,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   3,  49,  71,
  25,   4,  26,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,  40,   3,  41,  21,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,  69,  20,  70,  64,
};
yytok2 := array[] of {
   2,   3,   5,   6,   7,   8,   9,  10,  11,  12,
  13,  14,  15,  16,  17,  18,  19,  23,  24,  27,
  28,  29,  30,  36,  37,  42,  43,  44,  45,  46,
  47,  48,  50,  51,  52,  54,  55,  56,  57,  58,
  59,  60,  61,  62,  65,  66,  67,  68,  72,  73,
  74,  75,  76,  77,  78,  79,  80,  81,  82,  83,
  84,  85,  86,  87,  88,  89,  90,  91,  92,  93,
  94,  95,  96,
};
yytok3 := array[] of {
   0
};

YYSys: module
{
	FD: adt
	{
		fd:	int;
	};
	fildes:		fn(fd: int): ref FD;
	fprint:		fn(fd: ref FD, s: string, *): int;
};

yysys: YYSys;
yystderr: ref YYSys->FD;

YYFLAG: con -1000;

# parser for yacc output

yytokname(yyc: int): string
{
	if(yyc > 0 && yyc <= len yytoknames && yytoknames[yyc-1] != nil)
		return yytoknames[yyc-1];
	return "<"+string yyc+">";
}

yystatname(yys: int): string
{
	if(yys >= 0 && yys < len yystates && yystates[yys] != nil)
		return yystates[yys];
	return "<"+string yys+">\n";
}

yylex1(yylex: ref YYLEX): int
{
	c : int;
	yychar := yylex.lex();
	if(yychar <= 0)
		c = yytok1[0];
	else if(yychar < len yytok1)
		c = yytok1[yychar];
	else if(yychar >= YYPRIVATE && yychar < YYPRIVATE+len yytok2)
		c = yytok2[yychar-YYPRIVATE];
	else{
		n := len yytok3;
		c = 0;
		for(i := 0; i < n; i+=2) {
			if(yytok3[i+0] == yychar) {
				c = yytok3[i+1];
				break;
			}
		}
		if(c == 0)
			c = yytok2[1];	# unknown char
	}
	if(yydebug >= 3)
		yysys->fprint(yystderr, "lex %.4ux %s\n", yychar, yytokname(c));
	return c;
}

YYS: adt
{
	yyv: YYSTYPE;
	yys: int;
};

yyparse(yylex: ref YYLEX): int
{
	if(yydebug >= 1 && yysys == nil) {
		yysys = load YYSys "$Sys";
		yystderr = yysys->fildes(2);
	}

	yys := array[YYMAXDEPTH] of YYS;

	yyval: YYSTYPE;
	yystate := 0;
	yychar := -1;
	yynerrs := 0;		# number of errors
	yyerrflag := 0;		# error recovery flag
	yyp := -1;
	yyn := 0;

yystack:
	for(;;){
		# put a state and value onto the stack
		if(yydebug >= 4)
			yysys->fprint(yystderr, "char %s in %s", yytokname(yychar), yystatname(yystate));

		yyp++;
		if(yyp >= YYMAXDEPTH) {
			yylex.error("yacc stack overflow");
			yyn = 1;
			break yystack;
		}
		yys[yyp].yys = yystate;
		yys[yyp].yyv = yyval;

		for(;;){
			yyn = yypact[yystate];
			if(yyn > YYFLAG) {	# simple state
				if(yychar < 0)
					yychar = yylex1(yylex);
				yyn += yychar;
				if(yyn >= 0 && yyn < YYLAST) {
					yyn = yyact[yyn];
					if(yychk[yyn] == yychar) { # valid shift
						yychar = -1;
						yyp++;
						if(yyp >= YYMAXDEPTH) {
							yylex.error("yacc stack overflow");
							yyn = 1;
							break yystack;
						}
						yystate = yyn;
						yys[yyp].yys = yystate;
						yys[yyp].yyv = yylex.lval;
						if(yyerrflag > 0)
							yyerrflag--;
						if(yydebug >= 4)
							yysys->fprint(yystderr, "char %s in %s", yytokname(yychar), yystatname(yystate));
						continue;
					}
				}
			}
		
			# default state action
			yyn = yydef[yystate];
			if(yyn == -2) {
				if(yychar < 0)
					yychar = yylex1(yylex);
		
				# look through exception table
				for(yyxi:=0;; yyxi+=2)
					if(yyexca[yyxi] == -1 && yyexca[yyxi+1] == yystate)
						break;
				for(yyxi += 2;; yyxi += 2) {
					yyn = yyexca[yyxi];
					if(yyn < 0 || yyn == yychar)
						break;
				}
				yyn = yyexca[yyxi+1];
				if(yyn < 0){
					yyn = 0;
					break yystack;
				}
			}

			if(yyn != 0)
				break;

			# error ... attempt to resume parsing
			if(yyerrflag == 0) { # brand new error
				yylex.error("syntax error");
				yynerrs++;
				if(yydebug >= 1) {
					yysys->fprint(yystderr, "%s", yystatname(yystate));
					yysys->fprint(yystderr, "saw %s\n", yytokname(yychar));
				}
			}

			if(yyerrflag != 3) { # incompletely recovered error ... try again
				yyerrflag = 3;
	
				# find a state where "error" is a legal shift action
				while(yyp >= 0) {
					yyn = yypact[yys[yyp].yys] + YYERRCODE;
					if(yyn >= 0 && yyn < YYLAST) {
						yystate = yyact[yyn];  # simulate a shift of "error"
						if(yychk[yystate] == YYERRCODE)
							continue yystack;
					}
	
					# the current yyp has no shift onn "error", pop stack
					if(yydebug >= 2)
						yysys->fprint(yystderr, "error recovery pops state %d, uncovers %d\n",
							yys[yyp].yys, yys[yyp-1].yys );
					yyp--;
				}
				# there is no state on the stack with an error shift ... abort
				yyn = 1;
				break yystack;
			}

			# no shift yet; clobber input char
			if(yydebug >= 2)
				yysys->fprint(yystderr, "error recovery discards %s\n", yytokname(yychar));
			if(yychar == YYEOFCODE) {
				yyn = 1;
				break yystack;
			}
			yychar = -1;
			# try again in the same state
		}
	
		# reduction by production yyn
		if(yydebug >= 2)
			yysys->fprint(yystderr, "reduce %d in:\n\t%s", yyn, yystatname(yystate));
	
		yypt := yyp;
		yyp -= yyr2[yyn];
#		yyval = yys[yyp+1].yyv;
		yym := yyn;
	
		# consult goto table to find next state
		yyn = yyr1[yyn];
		yyg := yypgo[yyn];
		yyj := yyg + yys[yyp].yys + 1;
	
		if(yyj >= YYLAST || yychk[yystate=yyact[yyj]] != -yyn)
			yystate = yyact[yyg];
		case yym {
			
1=>
#line	149	"limbo.y"
{
		impmods = yys[yypt-1].yyv.ids;
	}
2=>
#line	152	"limbo.y"
{
		tree = rotater(yys[yypt-0].yyv.node);
	}
3=>
#line	156	"limbo.y"
{
		impmods = nil;
		tree = rotater(yys[yypt-0].yyv.node);
	}
4=>
yyval.node = yys[yyp+1].yyv.node;
5=>
#line	164	"limbo.y"
{
		if(yys[yypt-1].yyv.node == nil)
			yyval.node = yys[yypt-0].yyv.node;
		else if(yys[yypt-0].yyv.node == nil)
			yyval.node = yys[yypt-1].yyv.node;
		else
			yyval.node = mkbin(Oseq, yys[yypt-1].yyv.node, yys[yypt-0].yyv.node);
	}
6=>
#line	175	"limbo.y"
{
		yyval.node = nil;
	}
7=>
yyval.node = yys[yyp+1].yyv.node;
8=>
yyval.node = yys[yyp+1].yyv.node;
9=>
yyval.node = yys[yyp+1].yyv.node;
10=>
yyval.node = yys[yyp+1].yyv.node;
11=>
#line	183	"limbo.y"
{
		yyval.node = mkbin(Oas, yys[yypt-3].yyv.node, yys[yypt-1].yyv.node);
	}
12=>
#line	187	"limbo.y"
{
		yyval.node = mkbin(Oas, yys[yypt-3].yyv.node, yys[yypt-1].yyv.node);
	}
13=>
#line	191	"limbo.y"
{
		yyval.node = mkbin(Odas, yys[yypt-3].yyv.node, yys[yypt-1].yyv.node);
	}
14=>
#line	195	"limbo.y"
{
		yyval.node = mkbin(Odas, yys[yypt-3].yyv.node, yys[yypt-1].yyv.node);
	}
15=>
#line	199	"limbo.y"
{
		yyerror("illegal declaration");
		yyval.node = nil;
	}
16=>
#line	204	"limbo.y"
{
		yyerror("illegal declaration");
		yyval.node = nil;
	}
17=>
yyval.node = yys[yyp+1].yyv.node;
18=>
#line	212	"limbo.y"
{
		yyval.node = mkbin(Oseq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
19=>
#line	218	"limbo.y"
{
		includef(yys[yypt-1].yyv.tok.v.idval);
		yyval.node = nil;
	}
20=>
#line	223	"limbo.y"
{
		yyval.node = typedecl(yys[yypt-4].yyv.ids, yys[yypt-1].yyv.ty);
	}
21=>
#line	227	"limbo.y"
{
		yyval.node = importdecl(yys[yypt-1].yyv.node, yys[yypt-4].yyv.ids);
		yyval.node.src.start = yys[yypt-4].yyv.ids.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
22=>
#line	233	"limbo.y"
{
		yyval.node = vardecl(yys[yypt-3].yyv.ids, yys[yypt-1].yyv.ty);
	}
23=>
#line	237	"limbo.y"
{
		yyval.node = mkbin(Ovardecli, vardecl(yys[yypt-5].yyv.ids, yys[yypt-3].yyv.ty), varinit(yys[yypt-5].yyv.ids, yys[yypt-1].yyv.node));
	}
24=>
#line	241	"limbo.y"
{
		yyval.node = condecl(yys[yypt-4].yyv.ids, yys[yypt-1].yyv.node);
	}
25=>
yyval.node = yys[yyp+1].yyv.node;
26=>
#line	248	"limbo.y"
{
		yyval.node = exdecl(yys[yypt-3].yyv.ids, nil);
	}
27=>
#line	252	"limbo.y"
{
		yyval.node = exdecl(yys[yypt-6].yyv.ids, revids(yys[yypt-2].yyv.ids));
	}
28=>
#line	258	"limbo.y"
{
		yys[yypt-5].yyv.ids.src.stop = yys[yypt-0].yyv.tok.src.stop;
		yyval.node = moddecl(yys[yypt-5].yyv.ids, rotater(yys[yypt-1].yyv.node));
	}
29=>
#line	265	"limbo.y"
{
		yyval.node = nil;
	}
30=>
#line	269	"limbo.y"
{
		if(yys[yypt-1].yyv.node == nil)
			yyval.node = yys[yypt-0].yyv.node;
		else if(yys[yypt-0].yyv.node == nil)
			yyval.node = yys[yypt-1].yyv.node;
		else
			yyval.node = mkn(Oseq, yys[yypt-1].yyv.node, yys[yypt-0].yyv.node);
	}
31=>
#line	278	"limbo.y"
{
		yyval.node = nil;
	}
32=>
#line	284	"limbo.y"
{
		yyval.node = fielddecl(Dglobal, typeids(yys[yypt-3].yyv.ids, yys[yypt-1].yyv.ty));
	}
33=>
yyval.node = yys[yyp+1].yyv.node;
34=>
#line	289	"limbo.y"
{
		yyval.node = typedecl(yys[yypt-4].yyv.ids, yys[yypt-1].yyv.ty);
	}
35=>
#line	293	"limbo.y"
{
		yyval.node = condecl(yys[yypt-4].yyv.ids, yys[yypt-1].yyv.node);
	}
36=>
yyval.node = yys[yyp+1].yyv.node;
37=>
#line	300	"limbo.y"
{
		yys[yypt-6].yyv.ids.src.stop = yys[yypt-0].yyv.tok.src.stop;
		yyval.node = adtdecl(yys[yypt-6].yyv.ids, rotater(yys[yypt-1].yyv.node));
		yyval.node.ty.polys = yys[yypt-3].yyv.ids;
	}
38=>
#line	306	"limbo.y"
{
		yys[yypt-8].yyv.ids.src.stop = yys[yypt-0].yyv.tok.src.stop;
		yyval.node = adtdecl(yys[yypt-8].yyv.ids, rotater(yys[yypt-1].yyv.node));
		yyval.node.ty.polys = yys[yypt-5].yyv.ids;
		yyval.node.ty.val = rotater(yys[yypt-3].yyv.node);
	}
39=>
#line	315	"limbo.y"
{
		yyval.node = nil;
	}
40=>
#line	319	"limbo.y"
{
		if(yys[yypt-1].yyv.node == nil)
			yyval.node = yys[yypt-0].yyv.node;
		else if(yys[yypt-0].yyv.node == nil)
			yyval.node = yys[yypt-1].yyv.node;
		else
			yyval.node = mkn(Oseq, yys[yypt-1].yyv.node, yys[yypt-0].yyv.node);
	}
41=>
#line	328	"limbo.y"
{
		yyval.node = nil;
	}
42=>
yyval.node = yys[yyp+1].yyv.node;
43=>
yyval.node = yys[yyp+1].yyv.node;
44=>
#line	336	"limbo.y"
{
		yyval.node = condecl(yys[yypt-4].yyv.ids, yys[yypt-1].yyv.node);
	}
45=>
#line	342	"limbo.y"
{
		yyval.node = nil;
	}
46=>
#line	346	"limbo.y"
{
		if(yys[yypt-1].yyv.node == nil)
			yyval.node = yys[yypt-0].yyv.node;
		else if(yys[yypt-0].yyv.node == nil)
			yyval.node = yys[yypt-1].yyv.node;
		else
			yyval.node = mkn(Oseq, yys[yypt-1].yyv.node, yys[yypt-0].yyv.node);
	}
47=>
#line	357	"limbo.y"
{
		for(d := yys[yypt-4].yyv.ids; d != nil; d = d.next)
			d.cyc = byte 1;
		yyval.node = fielddecl(Dfield, typeids(yys[yypt-4].yyv.ids, yys[yypt-1].yyv.ty));
	}
48=>
#line	363	"limbo.y"
{
		yyval.node = fielddecl(Dfield, typeids(yys[yypt-3].yyv.ids, yys[yypt-1].yyv.ty));
	}
49=>
#line	369	"limbo.y"
{
		yyval.node = yys[yypt-1].yyv.node;
	}
50=>
#line	375	"limbo.y"
{
		yys[yypt-1].yyv.node.right.right = yys[yypt-0].yyv.node;
		yyval.node = yys[yypt-1].yyv.node;
	}
51=>
#line	380	"limbo.y"
{
		yyval.node = nil;
	}
52=>
#line	384	"limbo.y"
{
		yyval.node = nil;
	}
53=>
#line	390	"limbo.y"
{
		yyval.node = mkn(Opickdecl, nil, mkn(Oseq, fielddecl(Dtag, yys[yypt-1].yyv.ids), nil));
		typeids(yys[yypt-1].yyv.ids, mktype(yys[yypt-1].yyv.ids.src.start, yys[yypt-1].yyv.ids.src.stop, Tadtpick, nil, nil));
	}
54=>
#line	395	"limbo.y"
{
		yys[yypt-3].yyv.node.right.right = yys[yypt-2].yyv.node;
		yyval.node = mkn(Opickdecl, yys[yypt-3].yyv.node, mkn(Oseq, fielddecl(Dtag, yys[yypt-1].yyv.ids), nil));
		typeids(yys[yypt-1].yyv.ids, mktype(yys[yypt-1].yyv.ids.src.start, yys[yypt-1].yyv.ids.src.stop, Tadtpick, nil, nil));
	}
55=>
#line	401	"limbo.y"
{
		yyval.node = mkn(Opickdecl, nil, mkn(Oseq, fielddecl(Dtag, yys[yypt-1].yyv.ids), nil));
		typeids(yys[yypt-1].yyv.ids, mktype(yys[yypt-1].yyv.ids.src.start, yys[yypt-1].yyv.ids.src.stop, Tadtpick, nil, nil));
	}
56=>
#line	408	"limbo.y"
{
		yyval.ids = revids(yys[yypt-0].yyv.ids);
	}
57=>
#line	414	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval, nil, nil);
	}
58=>
#line	418	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval, nil, yys[yypt-2].yyv.ids);
	}
59=>
#line	424	"limbo.y"
{
		yyval.ids = revids(yys[yypt-0].yyv.ids);
	}
60=>
#line	430	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval, nil, nil);
	}
61=>
#line	434	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval, nil, yys[yypt-2].yyv.ids);
	}
62=>
#line	440	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-5].yyv.tok.src.start, yys[yypt-0].yyv.tok.src.stop, Tfix, nil, nil);
		yyval.ty.val = mkbin(Oseq, yys[yypt-3].yyv.node, yys[yypt-1].yyv.node);
	}
63=>
#line	445	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-3].yyv.tok.src.start, yys[yypt-0].yyv.tok.src.stop, Tfix, nil, nil);
		yyval.ty.val = yys[yypt-1].yyv.node;
	}
64=>
#line	452	"limbo.y"
{
		yyval.types = addtype(yys[yypt-0].yyv.ty, nil);
	}
65=>
#line	456	"limbo.y"
{
		yyval.types = addtype(yys[yypt-0].yyv.ty, yys[yypt-2].yyv.types);
	}
66=>
#line	462	"limbo.y"
{
		yyval.ty = mkidtype(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval);
	}
67=>
#line	466	"limbo.y"
{
		yyval.ty = yys[yypt-0].yyv.ty;
	}
68=>
#line	470	"limbo.y"
{
		yyval.ty = yys[yypt-0].yyv.ty;
	}
69=>
#line	474	"limbo.y"
{
		yyval.ty = mkarrowtype(yys[yypt-2].yyv.ty.src.start, yys[yypt-0].yyv.tok.src.stop, yys[yypt-2].yyv.ty, yys[yypt-0].yyv.tok.v.idval);
	}
70=>
#line	478	"limbo.y"
{
		yyval.ty = mkarrowtype(yys[yypt-5].yyv.ty.src.start, yys[yypt-3].yyv.tok.src.stop, yys[yypt-5].yyv.ty, yys[yypt-3].yyv.tok.v.idval);
		yyval.ty = mkinsttype(yys[yypt-5].yyv.ty.src, yyval.ty, yys[yypt-1].yyv.types);
	}
71=>
#line	483	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-1].yyv.tok.src.start, yys[yypt-0].yyv.ty.src.stop, Tref, yys[yypt-0].yyv.ty, nil);
	}
72=>
#line	487	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-2].yyv.tok.src.start, yys[yypt-0].yyv.ty.src.stop, Tchan, yys[yypt-0].yyv.ty, nil);
	}
73=>
#line	491	"limbo.y"
{
		if(yys[yypt-1].yyv.ids.next == nil)
			yyval.ty = yys[yypt-1].yyv.ids.ty;
		else
			yyval.ty = mktype(yys[yypt-2].yyv.tok.src.start, yys[yypt-0].yyv.tok.src.stop, Ttuple, nil, revids(yys[yypt-1].yyv.ids));
	}
74=>
#line	498	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-2].yyv.tok.src.start, yys[yypt-0].yyv.ty.src.stop, Tarray, yys[yypt-0].yyv.ty, nil);
	}
75=>
#line	502	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-2].yyv.tok.src.start, yys[yypt-0].yyv.ty.src.stop, Tlist, yys[yypt-0].yyv.ty, nil);
	}
76=>
#line	506	"limbo.y"
{
		yys[yypt-1].yyv.ty.src.start = yys[yypt-3].yyv.tok.src.start;
		yys[yypt-1].yyv.ty.polys = yys[yypt-2].yyv.ids;
		yys[yypt-1].yyv.ty.eraises = yys[yypt-0].yyv.node;
		yyval.ty = yys[yypt-1].yyv.ty;
	}
77=>
yyval.ty = yys[yyp+1].yyv.ty;
78=>
#line	526	"limbo.y"
{
		yyval.ty = mkidtype(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval);
	}
79=>
#line	530	"limbo.y"
{
		yyval.ty = mkinsttype(yys[yypt-3].yyv.tok.src, mkidtype(yys[yypt-3].yyv.tok.src, yys[yypt-3].yyv.tok.v.idval), yys[yypt-1].yyv.types);
	}
80=>
#line	536	"limbo.y"
{
		yyval.ty = mkdottype(yys[yypt-2].yyv.ty.src.start, yys[yypt-0].yyv.tok.src.stop, yys[yypt-2].yyv.ty, yys[yypt-0].yyv.tok.v.idval);
	}
81=>
#line	540	"limbo.y"
{
		yyval.ty = mkdottype(yys[yypt-5].yyv.ty.src.start, yys[yypt-3].yyv.tok.src.stop, yys[yypt-5].yyv.ty, yys[yypt-3].yyv.tok.v.idval);
		yyval.ty = mkinsttype(yys[yypt-5].yyv.ty.src, yyval.ty, yys[yypt-1].yyv.types);
	}
82=>
#line	547	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-0].yyv.ty.src, nil, yys[yypt-0].yyv.ty, nil);
	}
83=>
#line	551	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-2].yyv.ids.src, nil, yys[yypt-0].yyv.ty, yys[yypt-2].yyv.ids);
	}
84=>
#line	557	"limbo.y"
{
		yyval.ids = nil;
	}
85=>
#line	561	"limbo.y"
{
		yyval.ids = polydecl(yys[yypt-1].yyv.ids);
	}
86=>
#line	567	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-2].yyv.tok.src.start, yys[yypt-0].yyv.tok.src.stop, Tfn, tnone, yys[yypt-1].yyv.ids);
	}
87=>
#line	571	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-2].yyv.tok.src.start, yys[yypt-0].yyv.tok.src.stop, Tfn, tnone, nil);
		yyval.ty.varargs = byte 1;
	}
88=>
#line	576	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-4].yyv.tok.src.start, yys[yypt-0].yyv.tok.src.stop, Tfn, tnone, yys[yypt-3].yyv.ids);
		yyval.ty.varargs = byte 1;
	}
89=>
#line	583	"limbo.y"
{
		yyval.ty = yys[yypt-0].yyv.ty;
	}
90=>
#line	587	"limbo.y"
{
		yys[yypt-2].yyv.ty.tof = yys[yypt-0].yyv.ty;
		yys[yypt-2].yyv.ty.src.stop = yys[yypt-0].yyv.ty.src.stop;
		yyval.ty = yys[yypt-2].yyv.ty;
	}
91=>
#line	595	"limbo.y"
{
		yyval.ty = yys[yypt-0].yyv.ty;
	}
92=>
#line	599	"limbo.y"
{
		yyval.ty = yys[yypt-2].yyv.ty;
		yyval.ty.val = rotater(yys[yypt-0].yyv.node);
	}
93=>
#line	606	"limbo.y"
{
		yyval.ids = nil;
	}
94=>
yyval.ids = yys[yyp+1].yyv.ids;
95=>
yyval.ids = yys[yyp+1].yyv.ids;
96=>
#line	614	"limbo.y"
{
		yyval.ids = appdecls(yys[yypt-2].yyv.ids, yys[yypt-0].yyv.ids);
	}
97=>
#line	620	"limbo.y"
{
		yyval.ids = typeids(yys[yypt-2].yyv.ids, yys[yypt-0].yyv.ty);
	}
98=>
#line	624	"limbo.y"
{
		yyval.ids = typeids(yys[yypt-2].yyv.ids, yys[yypt-0].yyv.ty);
		for(d := yyval.ids; d != nil; d = d.next)
			d.implicit = byte 1;
	}
99=>
#line	630	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-2].yyv.node.src, enter("junk", 0), yys[yypt-0].yyv.ty, nil);
		yyval.ids.store = Darg;
		yyerror("illegal argument declaraion");
	}
100=>
#line	636	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-2].yyv.node.src, enter("junk", 0), yys[yypt-0].yyv.ty, nil);
		yyval.ids.store = Darg;
		yyerror("illegal argument declaraion");
	}
101=>
#line	644	"limbo.y"
{
		yyval.ids = revids(yys[yypt-0].yyv.ids);
	}
102=>
#line	650	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval, nil, nil);
		yyval.ids.store = Darg;
	}
103=>
#line	655	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-0].yyv.tok.src, nil, nil, nil);
		yyval.ids.store = Darg;
	}
104=>
#line	660	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval, nil, yys[yypt-2].yyv.ids);
		yyval.ids.store = Darg;
	}
105=>
#line	665	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-0].yyv.tok.src, nil, nil, yys[yypt-2].yyv.ids);
		yyval.ids.store = Darg;
	}
106=>
#line	672	"limbo.y"
{
		yyval.ty = yys[yypt-0].yyv.ty;
	}
107=>
#line	676	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-1].yyv.tok.src.start, yys[yypt-0].yyv.tok.src.stop, Tref, yys[yypt-0].yyv.ty, nil);
	}
108=>
#line	680	"limbo.y"
{
		yyval.ty = yys[yypt-0].yyv.ty;
	}
109=>
#line	684	"limbo.y"
{
		yyval.ty = mktype(yys[yypt-1].yyv.tok.src.start, yys[yypt-0].yyv.tok.src.stop, Tref, yys[yypt-0].yyv.ty, nil);
	}
110=>
#line	690	"limbo.y"
{
		yyval.node = fndecl(yys[yypt-3].yyv.node, yys[yypt-2].yyv.ty, yys[yypt-0].yyv.node);
		nfns++;
		# patch up polydecs
		if(yys[yypt-3].yyv.node.op == Odot){
			if(yys[yypt-3].yyv.node.right.left != nil){
				yys[yypt-2].yyv.ty.polys = yys[yypt-3].yyv.node.right.left.decl;
				yys[yypt-3].yyv.node.right.left = nil;
			}
			if(yys[yypt-3].yyv.node.left.op == Oname && yys[yypt-3].yyv.node.left.left != nil){
				yyval.node.decl = yys[yypt-3].yyv.node.left.left.decl;
				yys[yypt-3].yyv.node.left.left = nil;
			}
		}
		else{
			if(yys[yypt-3].yyv.node.left != nil){
				yys[yypt-2].yyv.ty.polys = yys[yypt-3].yyv.node.left.decl;
				yys[yypt-3].yyv.node.left = nil;
			}
		}
		yys[yypt-2].yyv.ty.eraises = yys[yypt-1].yyv.node;
		yyval.node.src = yys[yypt-3].yyv.node.src;
	}
111=>
#line	716	"limbo.y"
{
		yyval.node = mkn(Otuple, rotater(yys[yypt-1].yyv.node), nil);
		yyval.node.src.start = yys[yypt-3].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
112=>
#line	722	"limbo.y"
{
		yyval.node = nil;
	}
113=>
#line	728	"limbo.y"
{
		if(yys[yypt-1].yyv.node == nil){
			yys[yypt-1].yyv.node = mkn(Onothing, nil, nil);
			yys[yypt-1].yyv.node.src.start = curline();
			yys[yypt-1].yyv.node.src.stop = yys[yypt-1].yyv.node.src.start;
		}
		yyval.node = rotater(yys[yypt-1].yyv.node);
		yyval.node.src.start = yys[yypt-2].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
114=>
#line	739	"limbo.y"
{
		yyval.node = mkn(Onothing, nil, nil);
	}
115=>
#line	743	"limbo.y"
{
		yyval.node = mkn(Onothing, nil, nil);
	}
116=>
#line	749	"limbo.y"
{
		yyval.node = mkname(yys[yypt-1].yyv.tok.src, yys[yypt-1].yyv.tok.v.idval);
		if(yys[yypt-0].yyv.ids != nil){
			yyval.node.left = mkn(Onothing, nil ,nil);
			yyval.node.left.decl = yys[yypt-0].yyv.ids;
		}
	}
117=>
#line	757	"limbo.y"
{
		yyval.node = mkbin(Odot, yys[yypt-3].yyv.node, mkname(yys[yypt-1].yyv.tok.src, yys[yypt-1].yyv.tok.v.idval));
		if(yys[yypt-0].yyv.ids != nil){
			yyval.node.right.left = mkn(Onothing, nil ,nil);
			yyval.node.right.left.decl = yys[yypt-0].yyv.ids;
		}
	}
118=>
#line	767	"limbo.y"
{
		yyval.node = nil;
	}
119=>
#line	771	"limbo.y"
{
		if(yys[yypt-1].yyv.node == nil)
			yyval.node = yys[yypt-0].yyv.node;
		else if(yys[yypt-0].yyv.node == nil)
			yyval.node = yys[yypt-1].yyv.node;
		else
			yyval.node = mkbin(Oseq, yys[yypt-1].yyv.node, yys[yypt-0].yyv.node);
	}
120=>
#line	780	"limbo.y"
{
		if(yys[yypt-1].yyv.node == nil)
			yyval.node = yys[yypt-0].yyv.node;
		else
			yyval.node = mkbin(Oseq, yys[yypt-1].yyv.node, yys[yypt-0].yyv.node);
	}
123=>
#line	793	"limbo.y"
{
		yyval.node = mkn(Onothing, nil, nil);
		yyval.node.src.start = curline();
		yyval.node.src.stop = yyval.node.src.start;
	}
124=>
#line	799	"limbo.y"
{
		yyval.node = mkn(Onothing, nil, nil);
		yyval.node.src.start = curline();
		yyval.node.src.stop = yyval.node.src.start;
	}
125=>
#line	805	"limbo.y"
{
		yyval.node = mkn(Onothing, nil, nil);
		yyval.node.src.start = curline();
		yyval.node.src.stop = yyval.node.src.start;
	}
126=>
#line	811	"limbo.y"
{
		if(yys[yypt-1].yyv.node == nil){
			yys[yypt-1].yyv.node = mkn(Onothing, nil, nil);
			yys[yypt-1].yyv.node.src.start = curline();
			yys[yypt-1].yyv.node.src.stop = yys[yypt-1].yyv.node.src.start;
		}
		yyval.node = mkscope(rotater(yys[yypt-1].yyv.node));
	}
127=>
#line	820	"limbo.y"
{
		yyerror("illegal declaration");
		yyval.node = mkn(Onothing, nil, nil);
		yyval.node.src.start = curline();
		yyval.node.src.stop = yyval.node.src.start;
	}
128=>
#line	827	"limbo.y"
{
		yyerror("illegal declaration");
		yyval.node = mkn(Onothing, nil, nil);
		yyval.node.src.start = curline();
		yyval.node.src.stop = yyval.node.src.start;
	}
129=>
#line	834	"limbo.y"
{
		yyval.node = yys[yypt-1].yyv.node;
	}
130=>
#line	838	"limbo.y"
{
		yyval.node = mkn(Oif, yys[yypt-2].yyv.node, mkunary(Oseq, yys[yypt-0].yyv.node));
		yyval.node.src.start = yys[yypt-4].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.node.src.stop;
	}
131=>
#line	844	"limbo.y"
{
		yyval.node = mkn(Oif, yys[yypt-4].yyv.node, mkbin(Oseq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node));
		yyval.node.src.start = yys[yypt-6].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.node.src.stop;
	}
132=>
#line	850	"limbo.y"
{
		yyval.node = mkunary(Oseq, yys[yypt-0].yyv.node);
		if(yys[yypt-2].yyv.node.op != Onothing)
			yyval.node.right = yys[yypt-2].yyv.node;
		yyval.node = mkbin(Ofor, yys[yypt-4].yyv.node, yyval.node);
		yyval.node.decl = yys[yypt-9].yyv.ids;
		if(yys[yypt-6].yyv.node.op != Onothing)
			yyval.node = mkbin(Oseq, yys[yypt-6].yyv.node, yyval.node);
	}
133=>
#line	860	"limbo.y"
{
		yyval.node = mkn(Ofor, yys[yypt-2].yyv.node, mkunary(Oseq, yys[yypt-0].yyv.node));
		yyval.node.src.start = yys[yypt-4].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.node.src.stop;
		yyval.node.decl = yys[yypt-5].yyv.ids;
	}
134=>
#line	867	"limbo.y"
{
		yyval.node = mkn(Odo, yys[yypt-2].yyv.node, yys[yypt-5].yyv.node);
		yyval.node.src.start = yys[yypt-6].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-1].yyv.tok.src.stop;
		yyval.node.decl = yys[yypt-7].yyv.ids;
	}
135=>
#line	874	"limbo.y"
{
		yyval.node = mkn(Obreak, nil, nil);
		yyval.node.decl = yys[yypt-1].yyv.ids;
		yyval.node.src = yys[yypt-2].yyv.tok.src;
	}
136=>
#line	880	"limbo.y"
{
		yyval.node = mkn(Ocont, nil, nil);
		yyval.node.decl = yys[yypt-1].yyv.ids;
		yyval.node.src = yys[yypt-2].yyv.tok.src;
	}
137=>
#line	886	"limbo.y"
{
		yyval.node = mkn(Oret, yys[yypt-1].yyv.node, nil);
		yyval.node.src = yys[yypt-2].yyv.tok.src;
		if(yys[yypt-1].yyv.node.op == Onothing)
			yyval.node.left = nil;
		else
			yyval.node.src.stop = yys[yypt-1].yyv.node.src.stop;
	}
138=>
#line	895	"limbo.y"
{
		yyval.node = mkn(Ospawn, yys[yypt-1].yyv.node, nil);
		yyval.node.src.start = yys[yypt-2].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-1].yyv.node.src.stop;
	}
139=>
#line	901	"limbo.y"
{
		yyval.node = mkn(Oraise, yys[yypt-1].yyv.node, nil);
		yyval.node.src.start = yys[yypt-2].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-1].yyv.node.src.stop;
	}
140=>
#line	907	"limbo.y"
{
		yyval.node = mkn(Ocase, yys[yypt-3].yyv.node, caselist(yys[yypt-1].yyv.node, nil));
		yyval.node.src = yys[yypt-3].yyv.node.src;
		yyval.node.decl = yys[yypt-5].yyv.ids;
	}
141=>
#line	913	"limbo.y"
{
		yyval.node = mkn(Oalt, caselist(yys[yypt-1].yyv.node, nil), nil);
		yyval.node.src = yys[yypt-3].yyv.tok.src;
		yyval.node.decl = yys[yypt-4].yyv.ids;
	}
142=>
#line	919	"limbo.y"
{
		yyval.node = mkn(Opick, mkbin(Odas, mkname(yys[yypt-5].yyv.tok.src, yys[yypt-5].yyv.tok.v.idval), yys[yypt-3].yyv.node), caselist(yys[yypt-1].yyv.node, nil));
		yyval.node.src.start = yys[yypt-5].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-3].yyv.node.src.stop;
		yyval.node.decl = yys[yypt-7].yyv.ids;
	}
143=>
#line	926	"limbo.y"
{
		yyval.node = mkn(Oexit, nil, nil);
		yyval.node.src = yys[yypt-1].yyv.tok.src;
	}
144=>
#line	931	"limbo.y"
{
		if(yys[yypt-6].yyv.node == nil){
			yys[yypt-6].yyv.node = mkn(Onothing, nil, nil);
			yys[yypt-6].yyv.node.src.start = yys[yypt-6].yyv.node.src.stop = curline();
		}
		yys[yypt-6].yyv.node = mkscope(rotater(yys[yypt-6].yyv.node));
		yyval.node = mkbin(Oexstmt, yys[yypt-6].yyv.node, mkn(Oexcept, yys[yypt-3].yyv.node, caselist(yys[yypt-1].yyv.node, nil)));
	}
145=>
#line	946	"limbo.y"
{
		yyval.ids = nil;
	}
146=>
#line	950	"limbo.y"
{
		if(yys[yypt-1].yyv.ids.next != nil)
			yyerror("only one identifier allowed in a label");
		yyval.ids = yys[yypt-1].yyv.ids;
	}
147=>
#line	958	"limbo.y"
{
		yyval.ids = nil;
	}
148=>
#line	962	"limbo.y"
{
		yyval.ids = mkids(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval, nil, nil);
	}
149=>
#line	968	"limbo.y"
{
		yys[yypt-1].yyv.node.left.right.right = yys[yypt-0].yyv.node;
		yyval.node = yys[yypt-1].yyv.node;
	}
150=>
#line	975	"limbo.y"
{
		yyval.node = mkunary(Oseq, mkscope(mkunary(Olabel, rotater(yys[yypt-1].yyv.node))));
	}
151=>
#line	979	"limbo.y"
{
		yys[yypt-3].yyv.node.left.right.right = yys[yypt-2].yyv.node;
		yyval.node = mkbin(Oseq, mkscope(mkunary(Olabel, rotater(yys[yypt-1].yyv.node))), yys[yypt-3].yyv.node);
	}
152=>
#line	986	"limbo.y"
{
		yys[yypt-1].yyv.node.left.right = mkscope(yys[yypt-0].yyv.node);
		yyval.node = yys[yypt-1].yyv.node;
	}
153=>
#line	993	"limbo.y"
{
		yyval.node = mkunary(Oseq, mkunary(Olabel, rotater(yys[yypt-1].yyv.node)));
	}
154=>
#line	997	"limbo.y"
{
		yys[yypt-3].yyv.node.left.right = mkscope(yys[yypt-2].yyv.node);
		yyval.node = mkbin(Oseq, mkunary(Olabel, rotater(yys[yypt-1].yyv.node)), yys[yypt-3].yyv.node);
	}
155=>
#line	1004	"limbo.y"
{
		yys[yypt-1].yyv.node.left.right = mkscope(yys[yypt-0].yyv.node);
		yyval.node = yys[yypt-1].yyv.node;
	}
156=>
#line	1011	"limbo.y"
{
		yyval.node = mkunary(Oseq, mkunary(Olabel, rotater(yys[yypt-1].yyv.node)));
	}
157=>
#line	1015	"limbo.y"
{
		yys[yypt-3].yyv.node.left.right = mkscope(yys[yypt-2].yyv.node);
		yyval.node = mkbin(Oseq, mkunary(Olabel, rotater(yys[yypt-1].yyv.node)), yys[yypt-3].yyv.node);
	}
158=>
yyval.node = yys[yyp+1].yyv.node;
159=>
#line	1023	"limbo.y"
{
		yyval.node = mkbin(Orange, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
160=>
#line	1027	"limbo.y"
{
		yyval.node = mkn(Owild, nil, nil);
		yyval.node.src = yys[yypt-0].yyv.tok.src;
	}
161=>
#line	1032	"limbo.y"
{
		yyval.node = mkbin(Oseq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
162=>
#line	1036	"limbo.y"
{
		yyval.node = mkn(Onothing, nil, nil);
		yyval.node.src.start = curline();
		yyval.node.src.stop = yyval.node.src.start;
	}
163=>
#line	1044	"limbo.y"
{
		yys[yypt-1].yyv.node.left.right = mkscope(yys[yypt-0].yyv.node);
		yyval.node = yys[yypt-1].yyv.node;
	}
164=>
#line	1051	"limbo.y"
{
		yyval.node = mkunary(Oseq, mkunary(Olabel, rotater(yys[yypt-1].yyv.node)));
	}
165=>
#line	1055	"limbo.y"
{
		yys[yypt-3].yyv.node.left.right = mkscope(yys[yypt-2].yyv.node);
		yyval.node = mkbin(Oseq, mkunary(Olabel, rotater(yys[yypt-1].yyv.node)), yys[yypt-3].yyv.node);
	}
166=>
#line	1062	"limbo.y"
{
		yyval.node = mkname(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval);
	}
167=>
#line	1066	"limbo.y"
{
		yyval.node = mkn(Owild, nil, nil);
		yyval.node.src = yys[yypt-0].yyv.tok.src;
	}
168=>
#line	1071	"limbo.y"
{
		yyval.node = mkbin(Oseq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
169=>
#line	1075	"limbo.y"
{
		yyval.node = mkn(Onothing, nil, nil);
		yyval.node.src.start = curline();
		yyval.node.src.stop = yyval.node.src.start;
	}
170=>
#line	1083	"limbo.y"
{
		yyval.node = mkn(Onothing, nil, nil);
		yyval.node.src.start = curline();
		yyval.node.src.stop = yyval.node.src.start;
	}
171=>
yyval.node = yys[yyp+1].yyv.node;
172=>
yyval.node = yys[yyp+1].yyv.node;
173=>
#line	1093	"limbo.y"
{
		yyval.node = mkbin(Oas, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
174=>
#line	1097	"limbo.y"
{
		yyval.node = mkbin(Oandas, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
175=>
#line	1101	"limbo.y"
{
		yyval.node = mkbin(Ooras, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
176=>
#line	1105	"limbo.y"
{
		yyval.node = mkbin(Oxoras, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
177=>
#line	1109	"limbo.y"
{
		yyval.node = mkbin(Olshas, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
178=>
#line	1113	"limbo.y"
{
		yyval.node = mkbin(Orshas, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
179=>
#line	1117	"limbo.y"
{
		yyval.node = mkbin(Oaddas, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
180=>
#line	1121	"limbo.y"
{
		yyval.node = mkbin(Osubas, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
181=>
#line	1125	"limbo.y"
{
		yyval.node = mkbin(Omulas, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
182=>
#line	1129	"limbo.y"
{
		yyval.node = mkbin(Odivas, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
183=>
#line	1133	"limbo.y"
{
		yyval.node = mkbin(Omodas, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
184=>
#line	1137	"limbo.y"
{
		yyval.node = mkbin(Osnd, yys[yypt-3].yyv.node, yys[yypt-0].yyv.node);
	}
185=>
#line	1141	"limbo.y"
{
		yyval.node = mkbin(Odas, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
186=>
#line	1145	"limbo.y"
{
		yyval.node = mkn(Oload, yys[yypt-0].yyv.node, nil);
		yyval.node.src.start = yys[yypt-2].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.node.src.stop;
		yyval.node.ty = mkidtype(yys[yypt-1].yyv.tok.src, yys[yypt-1].yyv.tok.v.idval);
	}
187=>
#line	1152	"limbo.y"
{
		yyval.node = yyval.node = mkbin(Oexp, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
188=>
#line	1156	"limbo.y"
{
		yyval.node = mkbin(Omul, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
189=>
#line	1160	"limbo.y"
{
		yyval.node = mkbin(Odiv, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
190=>
#line	1164	"limbo.y"
{
		yyval.node = mkbin(Omod, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
191=>
#line	1168	"limbo.y"
{
		yyval.node = mkbin(Oadd, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
192=>
#line	1172	"limbo.y"
{
		yyval.node = mkbin(Osub, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
193=>
#line	1176	"limbo.y"
{
		yyval.node = mkbin(Orsh, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
194=>
#line	1180	"limbo.y"
{
		yyval.node = mkbin(Olsh, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
195=>
#line	1184	"limbo.y"
{
		yyval.node = mkbin(Olt, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
196=>
#line	1188	"limbo.y"
{
		yyval.node = mkbin(Ogt, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
197=>
#line	1192	"limbo.y"
{
		yyval.node = mkbin(Oleq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
198=>
#line	1196	"limbo.y"
{
		yyval.node = mkbin(Ogeq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
199=>
#line	1200	"limbo.y"
{
		yyval.node = mkbin(Oeq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
200=>
#line	1204	"limbo.y"
{
		yyval.node = mkbin(Oneq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
201=>
#line	1208	"limbo.y"
{
		yyval.node = mkbin(Oand, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
202=>
#line	1212	"limbo.y"
{
		yyval.node = mkbin(Oxor, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
203=>
#line	1216	"limbo.y"
{
		yyval.node = mkbin(Oor, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
204=>
#line	1220	"limbo.y"
{
		yyval.node = mkbin(Ocons, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
205=>
#line	1224	"limbo.y"
{
		yyval.node = mkbin(Oandand, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
206=>
#line	1228	"limbo.y"
{
		yyval.node = mkbin(Ooror, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
207=>
yyval.node = yys[yyp+1].yyv.node;
208=>
#line	1235	"limbo.y"
{
		yys[yypt-0].yyv.node.src.start = yys[yypt-1].yyv.tok.src.start;
		yyval.node = yys[yypt-0].yyv.node;
	}
209=>
#line	1240	"limbo.y"
{
		yyval.node = mkunary(Oneg, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
210=>
#line	1245	"limbo.y"
{
		yyval.node = mkunary(Onot, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
211=>
#line	1250	"limbo.y"
{
		yyval.node = mkunary(Ocomp, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
212=>
#line	1255	"limbo.y"
{
		yyval.node = mkunary(Oind, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
213=>
#line	1260	"limbo.y"
{
		yyval.node = mkunary(Opreinc, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
214=>
#line	1265	"limbo.y"
{
		yyval.node = mkunary(Opredec, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
215=>
#line	1270	"limbo.y"
{
		yyval.node = mkunary(Orcv, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
216=>
#line	1275	"limbo.y"
{
		yyval.node = mkunary(Ohd, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
217=>
#line	1280	"limbo.y"
{
		yyval.node = mkunary(Otl, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
218=>
#line	1285	"limbo.y"
{
		yyval.node = mkunary(Olen, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
219=>
#line	1290	"limbo.y"
{
		yyval.node = mkunary(Oref, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
220=>
#line	1295	"limbo.y"
{
		yyval.node = mkunary(Otagof, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
	}
221=>
#line	1300	"limbo.y"
{
		yyval.node = mkn(Oarray, yys[yypt-3].yyv.node, nil);
		yyval.node.ty = mktype(yys[yypt-5].yyv.tok.src.start, yys[yypt-0].yyv.ty.src.stop, Tarray, yys[yypt-0].yyv.ty, nil);
		yyval.node.src = yyval.node.ty.src;
	}
222=>
#line	1306	"limbo.y"
{
		yyval.node = mkn(Oarray, yys[yypt-5].yyv.node, yys[yypt-1].yyv.node);
		yyval.node.src.start = yys[yypt-7].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
223=>
#line	1312	"limbo.y"
{
		yyval.node = mkn(Onothing, nil, nil);
		yyval.node.src.start = yys[yypt-5].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-4].yyv.tok.src.stop;
		yyval.node = mkn(Oarray, yyval.node, yys[yypt-1].yyv.node);
		yyval.node.src.start = yys[yypt-6].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
224=>
#line	1321	"limbo.y"
{
		yyval.node = etolist(yys[yypt-1].yyv.node);
		yyval.node.src.start = yys[yypt-4].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
225=>
#line	1327	"limbo.y"
{
		yyval.node = mkn(Ochan, nil, nil);
		yyval.node.ty = mktype(yys[yypt-2].yyv.tok.src.start, yys[yypt-0].yyv.ty.src.stop, Tchan, yys[yypt-0].yyv.ty, nil);
		yyval.node.src = yyval.node.ty.src;
	}
226=>
#line	1333	"limbo.y"
{
		yyval.node = mkn(Ochan, yys[yypt-3].yyv.node, nil);
		yyval.node.ty = mktype(yys[yypt-5].yyv.tok.src.start, yys[yypt-0].yyv.ty.src.stop, Tchan, yys[yypt-0].yyv.ty, nil);
		yyval.node.src = yyval.node.ty.src;
	}
227=>
#line	1339	"limbo.y"
{
		yyval.node = mkunary(Ocast, yys[yypt-0].yyv.node);
		yyval.node.ty = mktype(yys[yypt-3].yyv.tok.src.start, yys[yypt-0].yyv.node.src.stop, Tarray, mkidtype(yys[yypt-1].yyv.tok.src, yys[yypt-1].yyv.tok.v.idval), nil);
		yyval.node.src = yyval.node.ty.src;
	}
228=>
#line	1345	"limbo.y"
{
		yyval.node = mkunary(Ocast, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
		yyval.node.ty = mkidtype(yyval.node.src, yys[yypt-1].yyv.tok.v.idval);
	}
229=>
#line	1351	"limbo.y"
{
		yyval.node = mkunary(Ocast, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
		yyval.node.ty = mkidtype(yyval.node.src, yys[yypt-1].yyv.tok.v.idval);
	}
230=>
#line	1357	"limbo.y"
{
		yyval.node = mkunary(Ocast, yys[yypt-0].yyv.node);
		yyval.node.src.start = yys[yypt-1].yyv.tok.src.start;
		yyval.node.ty = yys[yypt-1].yyv.ty;
	}
231=>
yyval.node = yys[yyp+1].yyv.node;
232=>
#line	1366	"limbo.y"
{
		yyval.node = mkn(Ocall, yys[yypt-3].yyv.node, yys[yypt-1].yyv.node);
		yyval.node.src.start = yys[yypt-3].yyv.node.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
233=>
#line	1372	"limbo.y"
{
		yyval.node = yys[yypt-1].yyv.node;
		if(yys[yypt-1].yyv.node.op == Oseq)
			yyval.node = mkn(Otuple, rotater(yys[yypt-1].yyv.node), nil);
		else
			yyval.node.flags |= byte PARENS;
		yyval.node.src.start = yys[yypt-2].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
234=>
#line	1382	"limbo.y"
{
#		n := mkdeclname($1, mkids($1, enter(".fn"+string nfnexp++, 0), nil, nil));
#		$<node>$ = fndef(n, $2);
#		nfns++;
	}
235=>
#line	1387	"limbo.y"
{
#		$$ = fnfinishdef($<node>3, $4);
#		$$ = mkdeclname($1, $$.left.decl);
		yyerror("urt unk");
		yyval.node = nil;
	}
236=>
#line	1394	"limbo.y"
{
		yyval.node = mkbin(Odot, yys[yypt-2].yyv.node, mkname(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval));
	}
237=>
#line	1398	"limbo.y"
{
		yyval.node = mkbin(Omdot, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
238=>
#line	1402	"limbo.y"
{
		yyval.node = mkbin(Oindex, yys[yypt-3].yyv.node, yys[yypt-1].yyv.node);
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
239=>
#line	1407	"limbo.y"
{
		if(yys[yypt-3].yyv.node.op == Onothing)
			yys[yypt-3].yyv.node.src = yys[yypt-2].yyv.tok.src;
		if(yys[yypt-1].yyv.node.op == Onothing)
			yys[yypt-1].yyv.node.src = yys[yypt-2].yyv.tok.src;
		yyval.node = mkbin(Oslice, yys[yypt-5].yyv.node, mkbin(Oseq, yys[yypt-3].yyv.node, yys[yypt-1].yyv.node));
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
240=>
#line	1416	"limbo.y"
{
		yyval.node = mkunary(Oinc, yys[yypt-1].yyv.node);
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
241=>
#line	1421	"limbo.y"
{
		yyval.node = mkunary(Odec, yys[yypt-1].yyv.node);
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
242=>
#line	1426	"limbo.y"
{
		yyval.node = mksconst(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval);
	}
243=>
#line	1430	"limbo.y"
{
		yyval.node = mkconst(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.ival);
		if(yys[yypt-0].yyv.tok.v.ival > big 16r7fffffff || yys[yypt-0].yyv.tok.v.ival < big -16r7fffffff)
			yyval.node.ty = tbig;
	}
244=>
#line	1436	"limbo.y"
{
		yyval.node = mkrconst(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.rval);
	}
245=>
#line	1440	"limbo.y"
{
		yyval.node = mkbin(Oindex, yys[yypt-5].yyv.node, rotater(mkbin(Oseq, yys[yypt-3].yyv.node, yys[yypt-1].yyv.node)));
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
246=>
#line	1447	"limbo.y"
{
		yyval.node = mkname(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval);
	}
247=>
#line	1451	"limbo.y"
{
		yyval.node = mknil(yys[yypt-0].yyv.tok.src);
	}
248=>
#line	1457	"limbo.y"
{
		yyval.node = mkn(Otuple, rotater(yys[yypt-1].yyv.node), nil);
		yyval.node.src.start = yys[yypt-2].yyv.tok.src.start;
		yyval.node.src.stop = yys[yypt-0].yyv.tok.src.stop;
	}
249=>
yyval.node = yys[yyp+1].yyv.node;
250=>
#line	1466	"limbo.y"
{
		yyval.node = mkbin(Oseq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
251=>
yyval.node = yys[yyp+1].yyv.node;
252=>
yyval.node = yys[yyp+1].yyv.node;
253=>
#line	1476	"limbo.y"
{
		yyval.node = mkn(Otype, nil, nil);
		yyval.node.ty = mkidtype(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval);
		yyval.node.src = yyval.node.ty.src;
	}
254=>
#line	1482	"limbo.y"
{
		yyval.node = mkn(Otype, nil, nil);
		yyval.node.ty = mktype(yys[yypt-2].yyv.tok.src.start, yys[yypt-0].yyv.ty.src.stop, Tarray, yys[yypt-0].yyv.ty, nil);
		yyval.node.src = yyval.node.ty.src;
	}
255=>
#line	1488	"limbo.y"
{
		yyval.node = mkn(Otype, nil, nil);
		yyval.node.ty = mktype(yys[yypt-2].yyv.tok.src.start, yys[yypt-0].yyv.ty.src.stop, Tlist, yys[yypt-0].yyv.ty, nil);
		yyval.node.src = yyval.node.ty.src;
	}
256=>
#line	1496	"limbo.y"
{
		yyval.node = mkname(yys[yypt-0].yyv.tok.src, yys[yypt-0].yyv.tok.v.idval);
	}
257=>
#line	1500	"limbo.y"
{
		yyval.node = nil;
	}
258=>
yyval.node = yys[yyp+1].yyv.node;
259=>
yyval.node = yys[yyp+1].yyv.node;
260=>
#line	1508	"limbo.y"
{
		yyval.node = mkbin(Oseq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
261=>
#line	1512	"limbo.y"
{
		yyval.node = mkbin(Oseq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
262=>
#line	1518	"limbo.y"
{
		yyval.node = nil;
	}
263=>
#line	1522	"limbo.y"
{
		yyval.node = rotater(yys[yypt-0].yyv.node);
	}
264=>
yyval.node = yys[yyp+1].yyv.node;
265=>
yyval.node = yys[yyp+1].yyv.node;
266=>
yyval.node = yys[yyp+1].yyv.node;
267=>
#line	1533	"limbo.y"
{
		yyval.node = mkbin(Oseq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
268=>
#line	1539	"limbo.y"
{
		yyval.node = rotater(yys[yypt-0].yyv.node);
	}
269=>
#line	1543	"limbo.y"
{
		yyval.node = rotater(yys[yypt-1].yyv.node);
	}
270=>
yyval.node = yys[yyp+1].yyv.node;
271=>
#line	1550	"limbo.y"
{
		yyval.node = mkbin(Oseq, yys[yypt-2].yyv.node, yys[yypt-0].yyv.node);
	}
272=>
#line	1556	"limbo.y"
{
		yyval.node = mkn(Oelem, nil, yys[yypt-0].yyv.node);
		yyval.node.src = yys[yypt-0].yyv.node.src;
	}
273=>
#line	1561	"limbo.y"
{
		yyval.node = mkbin(Oelem, rotater(yys[yypt-2].yyv.node), yys[yypt-0].yyv.node);
	}
274=>
#line	1567	"limbo.y"
{
		if(yys[yypt-1].yyv.node.op == Oseq)
			yys[yypt-1].yyv.node.right.left = rotater(yys[yypt-0].yyv.node);
		else
			yys[yypt-1].yyv.node.left = rotater(yys[yypt-0].yyv.node);
		yyval.node = yys[yypt-1].yyv.node;
	}
275=>
#line	1577	"limbo.y"
{
		yyval.node = typedecl(yys[yypt-1].yyv.ids, mktype(yys[yypt-1].yyv.ids.src.start, yys[yypt-0].yyv.tok.src.stop, Tpoly, nil, nil));
	}
276=>
#line	1581	"limbo.y"
{
		if(yys[yypt-3].yyv.node.op == Oseq)
			yys[yypt-3].yyv.node.right.left = rotater(yys[yypt-2].yyv.node);
		else
			yys[yypt-3].yyv.node.left = rotater(yys[yypt-2].yyv.node);
		yyval.node = mkbin(Oseq, yys[yypt-3].yyv.node, typedecl(yys[yypt-1].yyv.ids, mktype(yys[yypt-1].yyv.ids.src.start, yys[yypt-0].yyv.tok.src.stop, Tpoly, nil, nil)));
	}
		}
	}

	return yyn;
}
