implement Test;

include "sys.m";
include "env.m";
include "draw.m";
include "tk.m";

Test: module {
	init: fn(ctxt: ref Draw->Context, argv: list of string);
};

init(nil: ref Draw->Context, nil: list of string) {
	sys := load Sys Sys->PATH;
	env := load Env Env->PATH;
	draw := load Draw Draw->PATH;
	tk := load Tk Tk->PATH;

	Display, Font, Rect, Point, Image, Screen: import draw;

#	wsysfd := sys->open(env->getenv("wsys"), Sys->ORDWR);

#	sys->mount(wsysfd, nil, "/mnt/wsys", Sys->MREPL, "new -dx 800 -dy 800");

#	sys->bind("/mnt/wsys", "/dev", Sys->MBEFORE);

	display := draw->Display.allocate(nil);
	(wscr, wimg) := display.getwindow(nil, nil, nil, 1);

#	disp := display.image;
#	disp: Image;

	disp := wimg;
	red := display.color(Draw->Red);
	white := display.color(Draw->White);

	disp.drawop(disp.r, red, nil, disp.r.min, Draw->SoverD);

	texture := display.newimage(((0,0), (2,3)), disp.chans, 1, Draw->Black);
	texture.clipr = ((-10000, -10000), (10000, 10000));
	texture.drawop(((0, 0), (1, 3)), white, nil, (0,0), Draw->SoverD);
	texture.drawop(((0,0), (2,1)), white, nil, (0,0), Draw->SoverD);
	disp.drawop(((100, 100), (200, 300)), texture, texture, (0,0), Draw->SoverD);
#	sys->sleep(5000);

	font := Font.open(display, "*default*");
	disp.textop((100, 310), texture, (0, 0), font, "Hello world", Draw->SoverD);
	sys->sleep(10000);
}
