implement Hello;

include "sys.m";
include "env.m";

Hello: module
{
	init: fn();
};

sys: Sys;
env: Env;
wsys: string;

init()
{
	sys = load Sys Sys->PATH;
	env = load Env Env->PATH;

	# test FORKENV
	c := chan[0] of string;
	env->setenv("test", "init");
	spawn env_test(c, 1, nil);
	spawn env_test(c, 2, "bar");
	spawn env_test(c, 3, "foo");
	for(i := 0; i < 3; i++) {
		s := <- c;
		sys->print("%s\n", s);
	}
	sys->print("=init=%s\n", env->getenv("test"));

	# test FORKNS
	wsys = env->getenv("wsys");
	ns_test(0, "pre test");
	spawn ns_test(1, "hello");
	spawn ns_test(2, "world");
	ns_test(0, "post test");
	sys->sleep(20000);
}

env_test(c: chan of string, id: int, s: string) {
	sys->pctl(Sys->FORKENV, nil);

	if (s != nil) {
		env->setenv("test", s);
	}

	c <- = "=" + (string id) + "=" + env->getenv("test");
}

ns_test(id: int, s: string) {
	sys->pctl(Sys->FORKNS, nil);
	sys->print("%d: %s\n", id, wsys);
	wsysfd := sys->open(wsys, Sys->ORDWR);

	sys->print("%d: %d\n", id, wsysfd.fd);

	sys->mount(wsysfd, nil, "/tmp", Sys->MREPL, "new -dx 800 -dy 200");
	cons := sys->open("/tmp/cons", Sys->ORDWR);
	sys->fprint(cons, "id: %d\n%s\n", id, s);

	if (id > 0) {
		sys->sleep(20000);
	}
}